package solid;
import java.util.Hashtable;
/**
* Implementar a classe Serializable eh requisito para ser um
* Enterprise Bean. Um objeto de uma classe que implementa
* esta interface pode ser escrito em disco ou enviado pela rede.
* Nesta aplicao ser apenas verificado a consistncia dos dados.
*/

public class CruzBean implements java.io.Serializable {
/**
* Nomes dos atributos preferencialmente iguais aos usados
* no formulrio
*/
private String dcin1_s;
private String ccin1_s;
private String dcin2_s;
private String ccin2_s;
/* Este atributo serve para o controle de erros no formulrio */
private Hashtable erros;


public CruzBean() {
dcin1_s = "";
ccin1_s = "";
dcin2_s = "";
ccin2_s = "";
erros = new Hashtable();
}

/**
* Mtodos para acessar os atributos.
*/
public String getDiametro1(){ return dcin1_s; }
public String getComprimento1(){ return ccin1_s; }
public String getDiametro2(){ return dcin2_s; }
public String getComprimento2(){ return ccin2_s; }


public void setDiametro1(String valor){ dcin1_s = valor; }
public void setComprimento1(String valor){ ccin1_s = valor; }
public void setDiametro2(String valor){ dcin2_s = valor; }
public void setComprimento2(String valor){ ccin2_s = valor; }


public boolean ehValido(){
   if(verificaDiametro1() && verificaComprimento1() && verificaDiametro2() && verificaComprimento2()){
     return true;
   }

     return false;
}

protected boolean verificaDiametro1(){
   try{
      double temp = Double.parseDouble(dcin1_s);
      if(temp <= 0){
         erros.put("dcin1_s", "Digite um nmero positivo para o dimetro 1!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("dcin1_s", "Digite um nmero positivo para o dimetro 1!");
         return false;
    }
   return true;
 }

 protected boolean verificaComprimento1(){
   try{
      double temp = Double.parseDouble(ccin1_s);
      if(temp <= 0){
         erros.put("ccin1_s", "Digite um nmero positivo para o comprimento 1!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("ccin1_s", "Digite um nmero positivo para o comprimento 1!");
         return false;
    }
   return true;
 }

 protected boolean verificaDiametro2(){
   try{
      double temp = Double.parseDouble(dcin2_s);
      if(temp <= 0){
         erros.put("dcin2_s", "Digite um nmero positivo para o dimetro 2!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("dcin2_s", "Digite um nmero positivo para o dimetro 2!");
         return false;
    }
   return true;
 }

 protected boolean verificaComprimento2(){
   try{
      double temp = Double.parseDouble(ccin2_s);
      if(temp <= 0){
         erros.put("ccin2_s", "Digite um nmero positivo para o comprimento 2!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("ccin2_s", "Digite um nmero positivo para o comprimento 2!");
         return false;
    }
   return true;
 }



/**
*Usado para ver as mensagens de erro armazenados na tabela de Hash
*/
public String getErros (String s)
{
String msg = (String) erros.get(s);
return (msg == null) ? "" : msg;
}

/**
* Usado para colocar algum erro na tabela
*/
public void setErros (String chave, String msg)
{
erros.put(chave,msg);
}
}