#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "Nclient.h"

#define HOST	"lower"
#define PORT	7073

int main(int argc, char *argv[])
{

	N_RobotState *state;
	int error;
	
	error = N_InitializeClient(HOST, PORT);


	if (error != N_NO_ERROR){
		fprintf(stdout, "ERROR INITIALIZE : %d", error);
		fflush(stdout);
		exit(-1);
	}

	error = N_ConnectRobot(1);

	if (error != N_NO_ERROR){
		fprintf(stdout,"ERROR CONNECT : %d", error);
		fflush(stdout);
		exit(-1);
	}

	state =  N_GetRobotState(1);

	state->AxisSet.Global = TRUE;
	state->AxisSet.Axis[N_XTRANSLATION].Mode = N_AXIS_STOP;
	state->AxisSet.Axis[N_YTRANSLATION].Mode = N_AXIS_STOP;
	state->AxisSet.Axis[N_ROTATION].Mode = N_AXIS_STOP;
	state->AxisSet.Axis[N_XTRANSLATION].Update = TRUE;
	state->AxisSet.Axis[N_YTRANSLATION].Update = TRUE;
	state->AxisSet.Axis[N_ROTATION].Update = TRUE;

	if ((error = N_SetAxes(1)) != N_NO_ERROR)
	{

		fprintf(stdout,"ERROR STOP");
		fflush(stdout);
		exit(-1);
	}



	fprintf(stdout,"OK STOP");
	fflush(stdout);
	return 0;
}
