#ifndef MAKEMAP_H
#define MAKEMAP_H

#include "sema.h"

#include <fstream>

#include "sensonar.h"
#include "senir.h"
#include "senbumper.h"
#include "nomad.h"
#include "cinematic.h"
#include "util.h"

// The limit of sensor read that error is not big
#define READRADIUS 3000

// The range arc of sensors in degrees
#define ARC 15

// The value of cells
#define CELL_BUSY 9
#define CELL_TOLER 8
#define CELL_CLEAR 0
#define CELL_ROBOT 11
#define CELL_UNKNO -1

// The size of Map
#define MAP_WIDTH 300
#define MAP_HEIGHT 300



class MakeMap
{
	public:
		MakeMap();
		~MakeMap();
		int newMap();
		int openMap(char* filename);
		int saveMap(char* filename);
		int * getMap();
		void refreshMap(int posx, int posy);
		void refreshMap2(int posx, int posy);
		void finishThread();



	private:
		void paintSensorData(int sensor, int distancia, Coord robotPosition);
		void paintNomad(int posx, int posy);

		int mapa[MAP_WIDTH*MAP_HEIGHT];

		// Nomad Objects
		bool sensorsState;
		SenSonar *sonar;
		SenIr *ir;
		Cinematic *cinematic;
		struct N_RobotState* state;

};



#endif

