#ifndef NAVIGATOR_H
#define NAVIGATOR_H

#include "pathplanner.h"
#include "makemap.h"
#include "trefreshmap.h"
#include "tgetbattery.h"
#include "tgetposition.h"

#include "nomad.h"
#include "util.h"
#include "sensonar.h"
#include "senir.h"
#include "cinematic.h"


class Navigator
{
	public:
		Navigator();
		~Navigator();

		int start(int posx, int posy, char* map_filename);
		int finish();
		int move(int goal_x, int goal_y);
		int stop();
                float *getBatteryStatus();
		float *getPosition();

		MakeMap * makeMap;

	private:

		// Threads
		 gxThread_t *tptrRefreshMap;
		 TRefreshMap *tRefreshMap;

		 gxThread_t *tptrGetBattery;
		 TGetBattery *tGetBattery;
		 

		 gxThread_t *tptrGetPosition;
		 TGetPosition *tGetPosition;


		// Nomad objects
		Nomad *nomad;
		Cinematic *cinematic;
		struct N_RobotState* state;

		//PathPlanner
		typeTrajectory trajectory;
		PathPlanner *pathPlanner;

		//Posicoes iniciais
		int startX;
		int startY;

		//mutex
		gxMutex mutex;
		
		//baterias
		float *baterias;
		
		//posicoes
		float *posicoes;


};



#endif
