#ifndef PATHPLANNER_H
#define PATHPLANNER_H

#include <list>
#include "stlastar.h"
#include "util.h"


/* --------------------------------------------------------------
 * Class: 		MapSearchNode
 * Purpose: 	Defines the Nodes of a map in a search
 * --------------------------------------------------------------*/

class MapSearchNode
{
public:
	unsigned int x;	 // the (x,y) positions of the node
	unsigned int y;

	MapSearchNode() { x = y = 0; }
	MapSearchNode( unsigned int px, unsigned int py ) { x=px; y=py; }

	float GoalDistanceEstimate( MapSearchNode &nodeGoal );
	bool IsGoal( MapSearchNode &nodeGoal );
	bool GetSuccessors( AStarSearch<MapSearchNode> *astarsearch, MapSearchNode *parent_node );
	float GetCost( MapSearchNode &successor );
	bool IsSameState( MapSearchNode &rhs );

};

/* --------------------------------------------------------------
 * Class: 		PathPlanner
 * Purpose: 	Defines the pathplanner to get a trajectory
 * --------------------------------------------------------------*/

typedef list<Coord> typeTrajectory;

class PathPlanner
{
	public:
		PathPlanner(int map[20*20]);
		~PathPlanner();
		typeTrajectory getTrajectory(Coord start, Coord goal);

	private:
		typeTrajectory trajectory;


};
#endif
