#include <stdio.h>
#include <stdio_ext.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "navigator.h"
#include "makemap.h"
#include "sema.h"
#include "server.h"
#include "conector.h"


// Definicoes dos comandos para o server 

#define STARTNOMAD  1
#define FINISHNOMAD 2
#define MOVENOMAD   3
#define STOPNOMAD   4
#define GETMAP      5
#define GETBATTERY  6
#define GETPOSITION 7
#define SAVEMAP     8
#define END         9

int main(int argc, char *argv[])
{
	printf("0");
	fflush(stdout);
	printf("\n");

	Navigator *navigator;
	
	char cmd = 0;
	int pos[2];
	char file_name[256];
	int ret;


	Server mylink(8091,8092);

	mylink.connect();

	while (cmd != END)
	{
		mylink.recv_bytes(&cmd, 1);

		printf("CMD == %d\n", cmd);

		switch (cmd)
		{
		case STARTNOMAD  :
			{
				printf("Entrou aqui\n");
				navigator = new Navigator();
				memset(file_name, 0, 256);
				mylink.recv_ints(pos, 2);
				mylink.recv_string(file_name, 256, '\n');
				
				ret = navigator->start(pos[0], pos[1], file_name);
				mylink.send_ints(&ret, 1);
				
				break;
			}

		case FINISHNOMAD : 
			{
				ret = navigator->finish();				
				mylink.send_ints(&ret, 1);
				break;
			}

		case MOVENOMAD   :
			{
				mylink.recv_ints(pos, 2);
				ret = navigator->move(pos[0], pos[1]);
				mylink.send_ints(&ret, 1);
				break;
			}

		case STOPNOMAD   :
			{
				ret = navigator->stop();
				mylink.send_ints(&ret, 1);
				break;
			}
		case GETMAP      :
			{			
				int *localmap = navigator->makeMap->getMap();
				int *pix;

				if (localmap == NULL)
				{
					ret = 0;
					mylink.send_ints(&ret, 1);
					break;
				} 
				
				ret = 1;
				mylink.send_ints(&ret, 1);

				pix = (int*) malloc(300*300*sizeof(int));

				int cor;
				for (int i=0; i<300; i++)
					for (int j=0; j<300; j++)
					{
						cor = localmap[(i*300) + j];
						switch(cor){
						//Clear cells
						case CELL_CLEAR: pix[(299-i)*300 + j] = JAVA_white;
								 break;
						//Obstacle cells
						case CELL_BUSY:  pix[(299-i)*300 + j] = JAVA_black;
								 break;
						//Unknown cells
						case CELL_UNKNO: pix[(299-i)*300 + j] = JAVA_gray;
								 break;
						//Tolerance cells
						case CELL_TOLER: pix[(299-i)*300 + j] = JAVA_green;
								 break;
						default: 
								 break;
						}
					}
				mylink.send_ints(pix, 300*300);
				break;
			}

		case GETBATTERY  :
			{
				//float *bat = navigator->getBatteryStatus();
				float *bat = new float[4];

				bat[0] = 1;
				bat[1] = 2;
				bat[2] = 3;
				bat[3] = 4;

				mylink.send_floats(bat, 4);
				break;
			}
		case GETPOSITION :
			{
				float *position = navigator->getPosition();
				mylink.send_floats(position, 3);
				break;
			}
		case SAVEMAP     :
			{
				memset(file_name, 0, 256);
				mylink.recv_string(file_name, 256, '\n');
				
				ret = navigator->makeMap->saveMap(file_name);

				mylink.send_ints(&ret, 1);

				break;
			}
		default          :
			break;
		
		}

	}
	
	delete navigator;

	mylink.closesocket();

	return 0;

}	
