#include "header/navigator.h"

#include "gxdlcode.h"
#include "gxthread.h"
#include "gxmutex.h"
#include "makemap.h"

//Referencia para o navigator
Navigator *navigator;

// Simula a classe atualiza mapa do java
class TAtualizaMapa : public gxThread
{
public:

  TAtualizaMapa() { }
  ~TAtualizaMapa() { }

private: // Base class interface
  void *ThreadEntryRoutine(gxThread_t *thread);
  void ThreadExitRoutine(gxThread_t *thread);

};

void *TAtualizaMapa::ThreadEntryRoutine(gxThread_t *thread)
{
	int *localmap;
	gxMutex mut;
	printf("Entrou na TAtualiza Mapa\n");
	while (1)
	{
		mut.MutexLock();
		localmap = navigator->makeMap->getMap();
		mut.MutexUnlock();
		mSleep(500);

	}
}


void TAtualizaMapa::ThreadExitRoutine(gxThread_t *thread)
{
	printf("Saindo da thread TAtualizaMapa\n");
}


/********************************************************/

gxThread_t *tptrAtualiza;
TAtualizaMapa *tAtualiza;

void ini()
{
	printf("Iniciando o Nomad");
	navigator = new Navigator();

	navigator->start(800, 3000, "");

	tAtualiza = new TAtualizaMapa();

	tptrAtualiza = tAtualiza->CreateThread();

}

/********************************************************/
void mov()
{
	printf("Movendo o Robo\n");
	navigator->move(100,100);
}

/********************************************************/
void fim()
{

	printf("Finalizando o nomad\n");
	if (tptrAtualiza != 0)
	{
		tAtualiza->CancelThread(tptrAtualiza);
		tAtualiza->JoinThread(tptrAtualiza);

		if(int(tptrAtualiza->GetThreadExitCode()) != 0)
			printf("Erro finalizando a thread  TAtualiza\n");

		delete tptrAtualiza;
		delete tAtualiza;

		printf("Thread TAtualiza FINALIZADA COM SUCESSO \n");
	}

	if (navigator->finish() == 0)
	{
		//delete navigator;
	}

	printf("Nomad Finalizado\n");



}



int main(int* argc, char** argv)
{
   bool continua = true;

   while (continua)
   {
	printf("1 - Inicializa Nomad\n");
	printf("2 - Mover Nomad\n");
	printf("3 - Finaliza Nomad\n");
	printf("4 - Sair\n");
	printf("Escolha uma opcao:");

	char opc = getchar();
	switch (opc)
	{
		case '1': ini();
			  break;
		case '2': mov();
			  break;
		case '3': fim();
			  break;
		case '4': continua = false;
			  break;
		default:  printf("Opcao invalida\n");
			  break;
	}
   }
}


