#include "header/tgetbattery.h"

TGetBattery::TGetBattery(float *valores)
{
	nomad = new Nomad();
	baterias = valores;
	continua = true;
}



TGetBattery::~TGetBattery()
{
	delete nomad;

}

void TGetBattery::setContinua(bool cont)
{
	continua = cont;
}


void *TGetBattery::ThreadEntryRoutine(gxThread_t *thread)
{
	
	printf("Entrando thread bateria \n");
	GET_SEMAPHORE;

	if (nomad->Connect() != N_NO_ERROR)
	{
		printf("GET BATTERY: Erro ao conectar com o Nomad\n");
		return 0;
	}

	struct N_RobotState *state;

	while (continua)
	{
		ENTER_CRITICALSECTION;
			state = N_GetRobotState(1);
			baterias[0] = nomad->GetBattery(state, 0);
			baterias[1] = nomad->GetBattery(state, 1);
			baterias[2] = nomad->GetBattery(state, 2);
			baterias[3] = nomad->GetBattery(state, 3);
		LEAVE_CRITICALSECTION;
		sSleep(5);
	}




}

void TGetBattery::ThreadExitRoutine(gxThread_t *thread)
{

}
