#include "header/tgetposition.h"

TGetPosition::TGetPosition(float *valores)
{
	nomad = new Nomad();
	cinematic = new Cinematic();
	
	posicoes = valores;
	
	continua = true;
}



TGetPosition::~TGetPosition()
{
	delete nomad;

}


void TGetPosition::setContinua(bool cont)
{
	continua = cont;
}


void TGetPosition::setPosition(int x, int y)
{

	posx = x;
	posy = y;
}

void *TGetPosition::ThreadEntryRoutine(gxThread_t *thread)
{

	printf("trehad GetPosition \n");
	GET_SEMAPHORE;


	if (nomad->Connect() != N_NO_ERROR)
	{
		printf("GET Position: Erro ao conectar com o Nomad\n");
		return 0;
	}

	struct N_RobotState *state;
	Coord temp;

	while (continua)
	{
		ENTER_CRITICALSECTION;
			state = N_GetRobotState(1);
			temp = cinematic->GetOdometry(state);
			posicoes[0] = temp.x + posx;
			posicoes[1] = temp.y + posy;
			posicoes[2] = temp.rot;
		LEAVE_CRITICALSECTION;
		mSleep(500);
	}




}

void TGetPosition::ThreadExitRoutine(gxThread_t *thread)
{

}
