package navmap;

import javax.swing.JPanel;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;


/**
 * Classe que cria um mostrador para as baterias
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Marcio Moreira de Sousa e Paulo Roberto Corra Dutra
 * @version 1.0
 *
 */

public class Bateria extends JPanel {

  /**
   * Valor da tensao da bateria
   */
  private float valor;

  /**
   * Metodo Construtor
   */
  public Bateria() {
   this.setBorder(BorderFactory.createLoweredBevelBorder());
  }

  /**
   * Mtodo que atualiza os valores da bateria na tela
   * @param tensao tensao da bateria em [mV]
   */
  public void Atualiza(float tensao){
    valor = tensao/100;
  }

  /**
   * Mtodo interno para repintar os objetos na tela
   * @param g -
   */
  public void paintComponent(Graphics g) {
    //paint background
    super.paintComponent(g);
    if (valor > 0)
    {
        g.setColor(Color.red);
        g.fillRect(0,5,105, 10);
        g.setColor(Color.blue);
        g.fillRect(105,5,(int)((valor-95)*4.5)-105, 10);
    }
  }

}