package navmap;

import javax.swing.filechooser.FileFilter;
import java.io.File;

/**
 * Cria o filtro de arquivos de Mapas
 * <p>Title: NavMap</p>
 * <p>Description: Classe que cria um filtro para os arquivos de Mapa (.map)</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author unascribed
 * @version 1.0
 *
 */

public class MapaFilter extends FileFilter {

  // Aceita todos os diretrios e os arquivos de Mapas


   public boolean accept(File f) {
       if (f.isDirectory()) {
           return true;
       }

       String extension = Utils.getExtension(f);
       if (extension != null) {
           if (extension.equals(Utils.mapa) ){
               return true;
           } else {
               return false;
           }
           }

       return false;
   }

   // The description of this filter
   public String getDescription() {
       return "Arquivos de Mapas do NavMap v1.0";
   }

}