package navmap;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;

/**
 * Classe que cria o MenuPrincipal da Aplicao
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Paulo Roberto Correa Dutra & Marcio Moreira de Sousa
 * @version 1.0
 *
 */

public class MenuPrincipal extends JMenuBar {

  /**
   * Menu Sistema
   */
  private JMenu MenuSistema = new JMenu();
  private JMenuItem MenuSistema_Conectar = new JMenuItem();
  private JMenuItem MenuSistema_Desconectar = new JMenuItem();
  private JMenuItem MenuSistema_Sair = new JMenuItem();

  /**
   * Menu Mapa
   */
  private JMenu MenuMapa = new JMenu();
  private JMenuItem MenuMapa_Salvar = new JMenuItem();

  /**
   * Menu Ajuda
   */
  private JMenu MenuAjuda = new JMenu();
  private JMenuItem MenuAjuda_Sobre = new JMenuItem();
  private JMenuItem MenuAjuda_Conteudo = new JMenuItem();

  /**
   * Menu Config
   */
  private JMenu MenuConfig = new JMenu();
  private JRadioButtonMenuItem rbMenuItem;


  public void setMenuMapa_OFF()
  {
    this.MenuMapa.setEnabled(false);
  }

  /**
   * Construtor
   * @param listener Listener dos eventos para o menu
   */
  public MenuPrincipal(ActionListener listener) {

   /* Menu Sistema */
   MenuSistema.setMnemonic('S');
   MenuSistema.setText("Sistema");

   MenuSistema_Conectar.setMnemonic('C');
   MenuSistema_Conectar.setText("Conectar");
   MenuSistema_Conectar.setActionCommand("conectar");
   MenuSistema_Conectar.addActionListener(listener);

   MenuSistema_Desconectar.setMnemonic('D');
   MenuSistema_Desconectar.setText("Desconectar");
   MenuSistema_Desconectar.setActionCommand("desconectar");
   MenuSistema_Desconectar.setEnabled(false);
   MenuSistema_Desconectar.addActionListener(listener);

   MenuSistema_Sair.setMnemonic('S');
   MenuSistema_Sair.setText("Sair");
   MenuSistema_Sair.addActionListener(listener);

   MenuSistema.add(MenuSistema_Conectar);
   MenuSistema.add(MenuSistema_Desconectar);
   MenuSistema.add(MenuSistema_Sair);


   /* Menu Mapa */
   MenuMapa.setMnemonic('M');
   MenuMapa.setText("Mapas");

   MenuMapa_Salvar.setMnemonic('S');
   MenuMapa_Salvar.setText("Salvar");
   MenuMapa_Salvar.addActionListener(listener);

   MenuMapa.add(MenuMapa_Salvar);


   /* Menu Ajuda */
   MenuAjuda.setMnemonic('A');
   MenuAjuda.setText("Ajuda");

   MenuAjuda_Sobre.setMnemonic('S');
   MenuAjuda_Sobre.setText("Sobre");
   MenuAjuda_Sobre.addActionListener(listener);

   MenuAjuda_Conteudo.setMnemonic('C');
   MenuAjuda_Conteudo.setText("Conteudo");
   MenuAjuda_Conteudo.addActionListener(listener);

   MenuAjuda.add(MenuAjuda_Sobre);
   MenuAjuda.addSeparator();
   MenuAjuda.add(MenuAjuda_Conteudo);


   /* Menu Config */
   MenuConfig.setText("Config");
   MenuConfig.setMnemonic('C');

   ButtonGroup group = new ButtonGroup();

   rbMenuItem = new JRadioButtonMenuItem("Grid OFF");
   rbMenuItem.setSelected(true);
   group.add(rbMenuItem);
   rbMenuItem.addActionListener(listener);
   MenuConfig.add(rbMenuItem);

   rbMenuItem = new JRadioButtonMenuItem("Grid 100 mm");
   group.add(rbMenuItem);
   rbMenuItem.addActionListener(listener);
   MenuConfig.add(rbMenuItem);

   rbMenuItem = new JRadioButtonMenuItem("Grid 500 mm");
   group.add(rbMenuItem);
   rbMenuItem.addActionListener(listener);
   MenuConfig.add(rbMenuItem);

   rbMenuItem = new JRadioButtonMenuItem("Grid 1000 mm");
   group.add(rbMenuItem);
   rbMenuItem.addActionListener(listener);
   MenuConfig.add(rbMenuItem);

   /* Menu Principal */
   this.add(MenuSistema);
   this.add(MenuConfig);
   this.add(MenuMapa);
   this.add(MenuAjuda);


  }

  /**
   * Inverte os botoes de conectar e desconectar de acordo com o status do
   * Robo
   */
  public void invertMenuEnable()
  {
    if (MenuSistema_Desconectar.isEnabled())
    {
      MenuSistema_Desconectar.setEnabled(false);
      MenuSistema_Conectar.setEnabled(true);
    }
    else
    {
      MenuSistema_Desconectar.setEnabled(true);
      MenuSistema_Conectar.setEnabled(false);

    }
  }

  public MenuPrincipal() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
  }


} // End class MenuPrincipal
