package navmap;

import java.awt.Graphics;
import java.awt.image.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * Classe que contem os indicadores das baterias do Nomad
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author unascribed
 * @version 1.0
 */

public class PainelBaterias extends JPanel {

  /**
   * Bateria 1
   */
  private Bateria bat1;

  /**
   * Bateria 2
   */
  private Bateria bat2;

  /**
   * Bateria 3
   */
  private Bateria bat3;

  /**
   * Bateria 4
   */
  private Bateria bat4;

  private float[] valorbateria = new float[4];
  private Thread thread;
  private JLabel lbBat1 = new JLabel();
  private JLabel lbBat2 = new JLabel();
  private JLabel lbBat3 = new JLabel();
  private JLabel lbBat4 = new JLabel();
  private JLabel lb0V = new JLabel();
  private JLabel lb15V = new JLabel();
  private TitledBorder titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"");


  private boolean continua;

  private IConector conector;
  private ConectorFactory conectorFactory;



  /**
   * Tempo de Espera do Thread
   */
  private int timetowait = 5000;


  public void SetSleep(int valor){
    timetowait = valor;
  }


  /**
   * Inicializa as Threads de atualizaao dos Paineis
   */
  public void Inicializar(){
    continua = true;
    thread = new Thread(new AtualizaBaterias());
    thread.start();

  }

  /**
   * Finaliza as threads de atualizaao
   */
  public void Finalizar(){
    continua = false;
  }


  /**
   * Contrutor
   */
  public PainelBaterias(){
    bat1 = new Bateria();
    bat1.setBounds(new Rectangle(10, 25, 180, 20));

    bat2 = new Bateria();
    bat2.setBounds(new Rectangle(10, 75, 180, 20));

    bat3 = new Bateria();
    bat3.setBounds(new Rectangle(10, 125, 180, 20));

    bat4 = new Bateria();
    bat4.setBounds(new Rectangle(10, 175, 180, 20));

    lbBat1.setText("Bateria 1");
    lbBat2.setText("Bateria 2");
    lbBat3.setText("Bateria 3");
    lbBat4.setText("Bateria 4");

    lbBat1.setBounds(new Rectangle(10, 5,   173, 16));
    lbBat2.setBounds(new Rectangle(10, 55,  173, 16));
    lbBat3.setBounds(new Rectangle(10, 105, 173, 16));
    lbBat4.setBounds(new Rectangle(10, 155, 173, 16));

    this.setLayout(null);
    lb0V.setText("0 V");
    lb0V.setBounds(new Rectangle(5, 198, 20, 13));
    lb15V.setBounds(new Rectangle(165, 198, 30, 13));
    lb15V.setText("13 V");
    this.add(lbBat1, null);
    this.add(bat1, null);
    this.add(lbBat2, null);
    this.add(bat2, null);
    this.add(lbBat3, null);
    this.add(bat3, null);
    this.add(lbBat4, null);
    this.add(bat4, null);
    this.add(lb15V, null);
    this.add(lb0V, null);
    this.setBorder(titledBorder1);

    conectorFactory = conectorFactory.getInstance();
    conector = conectorFactory.getConector();


  }


  /**
   * Inner class para atualizao dos mostradores de baterias;
   */
  public class AtualizaBaterias implements Runnable{

    public void run(){

    while (continua){
      try{

        valorbateria = conector.getBatteryStatus();
        bat1.Atualiza(valorbateria[0]);
        bat2.Atualiza(valorbateria[1]);
        bat3.Atualiza(valorbateria[2]);
        bat4.Atualiza(valorbateria[3]);
        repaint();
        Thread.sleep(timetowait);

      }catch(InterruptedException e){
        e.printStackTrace();
      }
    }
  }
  }
}

