package navmap;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;


/**
 * Classe que mostra a posiao atual do nomad no painel de informaoes
 * Title:        NavMap
 * Description:  Navegao por Mapeamento
 * Copyright:    Copyright (c) 2002
 * Company:      Graco - UnB
 * @author Marcio Moreira de Sousa e Paulo Roberto Corra Dutra
 * @version 1.0
 *
 */

public class PainelPosicao extends JPanel {
  private JLabel lbPosx = new JLabel();
  private JLabel lbPosy = new JLabel();
  private JLabel lbPosrot = new JLabel();
  private JTextField ctPosx = new JTextField();
  private JTextField ctPosy = new JTextField();
  private JTextField ctPosrot = new JTextField();
  private JLabel lbmmx = new JLabel();
  private JLabel lbmmy = new JLabel();
  private JLabel lbmmrot = new JLabel();
  private float[] posicoes = new float[3];
  private IConector conector;
  private ConectorFactory conectorFactory;
  private TitledBorder titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Posio do Rob");


  private boolean continua;
  private Thread thread;



  /**
   * Tempo de Espera do Thread
   */
  private int timetowait = 500;


  public void SetSleep(int valor){
    timetowait = valor;
  }



  /**
   * Inicializa a thread
   */
  public void Inicializar(){
    continua = true;
    thread = new Thread(new AtualizaPosicoes());
    thread.start();

  }

  /**
   * Finaliza a thread
   */
  public void Finalizar(){
    continua = false;
  }


  /**
   * Construtor
   */
  public PainelPosicao() {
    try {
      jbInit();
      conectorFactory = conectorFactory.getInstance();
      conector = conectorFactory.getConector();


    }
    catch(Exception e) {
      e.printStackTrace();
    }




  }
  private void jbInit() throws Exception {
    lbPosx.setText("Eixo X");
    lbPosx.setBounds(new Rectangle(18, 18, 45, 15));
    this.setLayout(null);
    lbPosy.setText("Eixo Y");
    lbPosy.setBounds(new Rectangle(76, 18, 45, 15));
    lbPosrot.setText("Rotacao");
    lbPosrot.setBounds(new Rectangle(134, 18, 52, 15));
    ctPosx.setEnabled(false);
    ctPosx.setBounds(new Rectangle(19, 39, 45, 19));
    ctPosy.setEnabled(false);
    ctPosy.setBounds(new Rectangle(76, 39, 45, 19));
    ctPosrot.setEnabled(false);
    ctPosrot.setBounds(new Rectangle(134, 39, 45, 19));
    lbmmx.setText("mm");
    lbmmx.setBounds(new Rectangle(36, 59, 28, 15));
    lbmmy.setBounds(new Rectangle(96, 58, 25, 15));
    lbmmy.setText("mm");
    lbmmrot.setBounds(new Rectangle(147, 59, 32, 15));
    lbmmrot.setText("mrad");
    this.add(ctPosy, null);
    this.add(ctPosrot, null);
    this.add(lbPosx, null);
    this.add(lbPosy, null);
    this.add(lbPosrot, null);
    this.add(lbmmrot, null);
    this.add(lbmmy, null);
    this.add(ctPosx, null);
    this.add(lbmmx, null);
    this.setBorder(titledBorder1);
  }



  /**
   * Inner class para atualizao dos mostradores de posicas;
   */

  public class AtualizaPosicoes implements Runnable{

    public void run(){
    posicoes[0] = 0;
    posicoes[1] = 0;
    posicoes[2] = 0;

    while (continua){
      try{
        posicoes = conector.getPosition();
        ctPosx.setText(String.valueOf((int)posicoes[0]));
        ctPosy.setText(String.valueOf((int)posicoes[1]));
        ctPosrot.setText(String.valueOf((int)posicoes[2]));
        Thread.sleep(timetowait);

      }catch(InterruptedException e){
        e.printStackTrace();
      }
    }
  }
  }




}