package navmap;

import javax.swing.JPanel;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.JApplet;

/**
 * Painel que contem a Imagem que mostra o status do nomad
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Marcio Moreira de Sousa e Paulo Roberto Corra Dutra
 * @version 1.0
 *
 */

public class PainelStatus extends JPanel {


  private static final Image NomadON = Toolkit.getDefaultToolkit().createImage("images/xr4000_on.gif");
  private static final Image NomadOFF = Toolkit.getDefaultToolkit().createImage("images/xr4000_off.gif");

  private boolean status;

  /**
   * Configura o status do nomad
   * @param valor Status do Nomad (true = conectado)
   */
  public void setStatus(boolean valor){
    status = valor;
    this.repaint();
  }

  /**
   * construtor
   */
  public PainelStatus() {
      status = false;
  }


  public void paintComponent(Graphics g) {
    //paint Background
    super.paintComponent(g);
    if (status)
    {
      g.drawImage(NomadON,70,0,68,94,this);
    }
    else
    {
      g.drawImage(NomadOFF,70,0,68,94,this);
    }

  }
}