package navmap;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.io.File;

/**
 * Frame para pegar as entradas que o usuario precisa inserir antes de
 * iniciar a aplicao
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author unascribed
 * @version 1.0
 *
 */

public class TelaConexao extends JFrame {
  private JFileChooser fc = new JFileChooser();
  private JLabel lbArquivodeMapa = new JLabel();
  private JTextField ctNomeArquivo = new JTextField();
  private JButton btFileChooser = new JButton();
  private JPanel PanelPosicoes = new JPanel();
  private TitledBorder titledBorder1;
  private JLabel lbCoordX = new JLabel();
  private JLabel lbCoordY = new JLabel();
  private JTextField ctCoordX = new JTextField();
  private JTextField ctCoordY = new JTextField();
  private JButton btConectar = new JButton();
  private JPanel jPanel1 = new JPanel();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();

  /**
   * Construtor
   * @param listener listener para os eventos
   */
  public TelaConexao(ActionListener listener) {

    MapaFilter mapaFilter = new MapaFilter();
    fc.setFileFilter(mapaFilter);
    fc.setCurrentDirectory(new File("."));
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Posio Inicial do Rob no mapa");
    PanelPosicoes.setBorder(titledBorder1);
    PanelPosicoes.setToolTipText("Entre com a posicao inicial do centro do robo no mapa");
    PanelPosicoes.setBounds(new Rectangle(13, 51, 294, 81));
    PanelPosicoes.setLayout(null);
    lbArquivodeMapa.setText("Arquivo de Mapa");
    lbArquivodeMapa.setBounds(new Rectangle(13, 23, 118, 17));
    ctNomeArquivo.setToolTipText("Deixe em branco para criar um novo mapa");
    ctNomeArquivo.setBounds(new Rectangle(131, 20, 250, 21));
    btFileChooser.setBounds(new Rectangle(385, 21, 22, 19));
    btFileChooser.setText("...");
    btFileChooser.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btFileChooser_actionPerformed(e);
      }
    });
    lbCoordX.setText("X");
    lbCoordX.setBounds(new Rectangle(16, 26, 16, 17));
    lbCoordY.setText("Y");
    lbCoordY.setBounds(new Rectangle(17, 52, 18, 17));
    ctCoordX.setText("800");
    ctCoordX.setBounds(new Rectangle(34, 24, 82, 21));
    ctCoordY.setText("3000");
    ctCoordY.setBounds(new Rectangle(34, 50, 82, 21));
    btConectar.setBounds(new Rectangle(356, 102, 102, 27));
    btConectar.setText("Conectar");
    btConectar.setActionCommand("connect_nomad");
    btConectar.addActionListener(listener);

    jPanel1.setLayout(null);
    jPanel1.setVisible(true);
    jLabel1.setText("mm");
    jLabel1.setBounds(new Rectangle(117, 27, 45, 15));
    jLabel2.setText("mm");
    jLabel2.setBounds(new Rectangle(118, 53, 45, 15));
    this.getContentPane().add(jPanel1, null);
    this.getContentPane().add(jPanel1, null);
    jPanel1.add(PanelPosicoes, null);
    PanelPosicoes.add(lbCoordY, null);
    PanelPosicoes.add(jLabel2, null);
    PanelPosicoes.add(ctCoordY, null);
    PanelPosicoes.add(lbCoordX, null);
    PanelPosicoes.add(ctCoordX, null);
    PanelPosicoes.add(jLabel1, null);
    jPanel1.add(btFileChooser, null);
    jPanel1.add(ctNomeArquivo, null);
    jPanel1.add(lbArquivodeMapa, null);
    jPanel1.add(btConectar, null);

    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent we){
        dispose();
      }
    });


  }

  private void btFileChooser_actionPerformed(ActionEvent e) {
    // Filechooser
     fc.showOpenDialog(this);
     ctNomeArquivo.setText(fc.getSelectedFile().getAbsolutePath());

  }

  /**
   * Metodo que pega a coordenada X inicial
   * @return X
   */
  public int getStartCellX()
  {
    return Integer.parseInt(ctCoordX.getText());
  }

  /**
   * Metodo que pega a coordenada Y inicial
   * @return Y
   */
  public int getStartCellY()
  {
    return Integer.parseInt(ctCoordY.getText());
  }

  /**
   * Metodo que pega o nome do arquivo que contem o mapa inicial
   * @return nome do arquivo
   */

  public String getMapFileName()
  {
    return ctNomeArquivo.getText();
  }


}