package solid;
import java.util.Hashtable;
/**
* Implementar a classe Serializable eh requisito para ser um
* Enterprise Bean. Um objeto de uma classe que implementa
* esta interface pode ser escrito em disco ou enviado pela rede.
* Nesta aplicao ser apenas verificado a consistncia dos dados.
*/

 public class ParalelepipedoBean implements java.io.Serializable {
 /**
 * Nomes dos atributos preferencialmente iguais aos usados
 * no formulrio
 */
 private String comp_s;
 private String larg_s;
 private String altu_s;
 private Hashtable erros; /* Este atributo serve para o controle de erros no formulrio */


 public ParalelepipedoBean() {
    comp_s = "";
    larg_s = "";
    altu_s = "";
    erros = new Hashtable();
 }

 /**
 * Mtodos para acessar os atributos.
 */
 public String getComprimento(){ return comp_s; }
 public String getLargura(){ return larg_s; }
 public String getAltura(){ return altu_s; }
 
 public void setComprimento(String valor){ comp_s = valor; }
 public void setLargura(String valor){ larg_s = valor; }
 public void setAltura(String valor){ altu_s = valor; }
 
 /**
  * Mtodo utilizado para verificar a consistncia dos dados que
  * foram digitados pelo usurio
  */
 public boolean ehValido(){
    if(verificaComprimento() && verificaLargura() && verificaAltura()){
      return true;
    }

      return false;
 }

 protected boolean verificaComprimento(){
   try{
      double temp = Double.parseDouble(comp_s);
      if(temp <= 0){
         erros.put("comp_s", "Digite um nmero positivo para o comprimento!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("comp_s", "Digite um nmero positivo para o comprimento!");
         return false;
    }
   return true;
 }

 protected boolean verificaLargura(){
   try{
      double temp = Double.parseDouble(larg_s);
      if(temp <= 0){
         erros.put("larg_s", "Digite um nmero positivo para a largura!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("larg_s", "Digite um nmero positivo para a largura!");
         return false;
    }
   return true;
 }

 protected boolean verificaAltura(){
   try{
      double temp = Double.parseDouble(altu_s);
      if(temp <= 0){
         erros.put("altu_s", "Digite um nmero positivo para a altura!");
         return false;
      }
    }catch(NumberFormatException e){
         erros.put("altu_s", "Digite um nmero positivo para a altura!");
         return false;
     }
   return true;
 }

 /**
 *Usado para ver as mensagens de erro armazenados na tabela de Hash
 */
 public String getErros(String s){
    String msg = (String) erros.get(s);
    return (msg == null) ? "" : msg;
 }

 /**
 * Usado para colocar algum erro na tabela
 */
 public void setErros(String chave, String msg){
    erros.put(chave,msg);
 }

}//Fim da classe...