#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>

#define ENQ 0x05
#define ACK 0x06
#define WACK 0x0E
#define RVI 0x0F
#define NAK 0x15
#define DLE 0x10
#define STXeven 0x02
#define STXodd 0x82
#define ETX 0x03
#define EOT 0x04

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

char * cp;
char * empty = "<empty>";

main(int argc, char ** argv)
{
int coordx, coordy, coordz, fd, NOB, i, prog, ins, frame, tcp, keym, opm;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX, contato, BCS;
unsigned char Telegram_TX[8], Telegram_RX[62];
time_t TimeSec;

printf("Content-type: text/html\n\n");
printf("<body bgcolor=\"#ffffff\" text=\"#000000\">");
printf("<h4><center>CURRENT STATUS</center></h4><h5>");
fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

/* FASE 1 TRANSMISSAO */

Byte_TX= ENQ;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);

if (Byte_RX == ACK) contato = TRUE;
else if (Byte_RX == ENQ)
       { 
        read(fd,&Byte_RX,1);
        if (Byte_RX == ACK) contato = TRUE;
        else contato = FALSE;
       }
     else contato = FALSE;

/* DEFININDO O TELEGRAMA A SER TRANSMITIDO */

Telegram_TX[0]=0; 
Telegram_TX[1]=8;
Telegram_TX[2]=1;
Telegram_TX[3]=0;
Telegram_TX[4]=19;
Telegram_TX[5]=1;
Telegram_TX[6]=0;
Telegram_TX[7]=0;

/* FASE 2 TRANSMISSAO */

NOB = 8;
BCS=0;
for (i=0;i<NOB;i++)
BCS = BCS ^ Telegram_TX[i];
BCS = BCS ^ ETX;

Byte_TX = DLE;
write(fd,&Byte_TX,1);
Byte_TX = STXeven;
write(fd,&Byte_TX,1);


for(i=0;i<NOB;i++)
   {
    if (Telegram_TX[i] == DLE)
      {
       Byte_TX = DLE;
       write(fd,&Byte_TX,1);
      }
    write(fd,&Telegram_TX[i],1);
   }

Byte_TX = DLE;
write(fd,&Byte_TX,1);
Byte_TX = ETX;
write(fd,&Byte_TX,1);
Byte_TX = BCS;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);
if (Byte_RX == ACK) contato = TRUE;
if (Byte_RX == RVI) contato = TRUE;
if (Byte_RX == NAK) contato = FALSE;
if (Byte_RX != ACK) contato = FALSE;

if (contato == TRUE) 
   {   
    Byte_TX = EOT;
    write(fd,&Byte_TX,1);
   }

/* FASE 1 RECEPCAO */

read(fd,&Byte_RX,1);

if (Byte_RX == ENQ)
   {
    Byte_TX = ACK;
    write(fd,&Byte_TX,1);
   }
else contato = FALSE;

read(fd,&Byte_RX,1);
if (Byte_RX == DLE) read(fd,&Byte_RX,1);

BCS = 0;

for(i=0;i<62;i++)
   {
    read(fd,&Telegram_RX[i],1);
    if (Telegram_RX[i] == DLE) read(fd,&Byte_RX,1);
   }

read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
     
Byte_TX = ACK;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);
/* for(i=0;i<62;i++) printf("Telegrama[%d] = %d\n<br>",i,Telegram_RX[i]); 
*/

prog=Telegram_RX[12]*0x100+Telegram_RX[13];
printf("Prog#: %d\n<br>",prog);

ins=Telegram_RX[14]*0x100+Telegram_RX[15];
printf("Instruction#: %d\n<br>",ins);
printf("Frame: %d\n<br>",Telegram_RX[16]);
printf("TCP: %d\n<br>",Telegram_RX[17]);

i=Telegram_RX[18]/16;
i=Telegram_RX[18]-(i*16); /* numero obtido referente aos 4 primeiros bits
*/
keym = i/8;
if (keym>0) printf("Key Mode: TEACH\n<br>");
else printf("Key Mode: AUTO\n<br>");

i=i-(keym*16);

opm= i/4;
i=i-(opm*4);

opm= i/2;
if (opm>0) printf("Operation Mode: Program Under Execution\n<br>");
i=1-(opm*2);
if (i=0) printf("Operation Mode: Stand by\n<br>");
else printf("Operation Mode: Operation\n<br>");

coordx=Telegram_RX[20]*0x100+Telegram_RX[21];
coordy=Telegram_RX[22]*0x100+Telegram_RX[23];
coordz=Telegram_RX[24]*0x100+Telegram_RX[25];
printf("X: %d<br>",coordx);
printf("Y: %d<br>",coordy);
printf("Z: %d<br>",coordz);


printf("<br><br><center><form
action=\"http://webrobot.graco.unb.br/cgi-bin/f19\" method=\"get\"><input
type=\"Submit\" name=\"submit\" value=\"Update\">");

}
