#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>

#define ENQ 0x05
#define ACK 0x06
#define WACK 0x0E
#define RVI 0x0F
#define NAK 0x15
#define DLE 0x10
#define STXeven 0x02
#define STXodd 0x82
#define ETX 0x03
#define EOT 0x04

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

char * cp;
char * empty = "<empty>";

main(int argc, char ** argv)
{
int fd, NOB, i, PNUM;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX, contato, BCS, opt1, enviado[40];
unsigned char Telegram_TX[9],Telegram_RX[10];
time_t TimeSec;

printf("Content-type: text/html\n\n");
printf("<HTML><title></title><body bgcolor=\"#ffffff\"
text=\"#000000\"><br>");
#define safenv(a) ((cp = getenv(a)) ? cp : empty)

strcpy(enviado,safenv("QUERY_STRING"));
/* printf("O string enviado:<br>%s<br>",enviado); */

opt1='n';

if (enviado[0] == 's') 
   {
    opt1= 's';
    if (enviado[23] == '&')
       PNUM = (enviado[19]-48)*1000 + (enviado[20]-48)*100 +
              (enviado[21]-48)*10 + (enviado[22]-48);
    if (enviado[22] == '&')
       PNUM = (enviado[19]-48)*100 + (enviado[20]-48)*10 +
              (enviado[21]-48);
    if (enviado[21] == '&')
       PNUM = (enviado[19]-48)*10 + (enviado[20]-48)*1;
    if (enviado[20] == '&')
       PNUM = (enviado[19]-48);
   }
else 
   {
    if (enviado[13] == '&') 
       PNUM = (enviado[9]-48)*1000 + (enviado[10]-48)*100 + 
              (enviado[11]-48)*10 + (enviado[12]-48);
    if (enviado[12] == '&')
       PNUM = (enviado[9]-48)*100 + (enviado[10]-48)*10 +
              (enviado[11]-48);
    if (enviado[11] == '&')
       PNUM = (enviado[9]-48)*10 + (enviado[10]-48)*1;
    if (enviado[10] == '&')
       PNUM = (enviado[9]-48);
   }
    
printf("PROGRAMA %d EM EXECUCAO<br>",PNUM); 

Telegram_TX[8]=0;
Telegram_TX[9]=0;

Telegram_TX[8]=PNUM/256;
Telegram_TX[9]=PNUM - Telegram_TX[8]*256;
/* printf("[8]= %d\n<br>[9]= %d<br>",Telegram_TX[8],Telegram_TX[9]); */

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

/* FASE 1 TRANSMISSAO */

Byte_TX= ENQ;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);

if (Byte_RX == ACK) contato = TRUE;
else if (Byte_RX == ENQ)
       { 
        read(fd,&Byte_RX,1);
        if (Byte_RX == ACK) contato = TRUE;
        else contato = FALSE;
       }
     else contato = FALSE;

/* DEFININDO O TELEGRAMA A SER TRANSMITIDO */

Telegram_TX[0]=0; 
Telegram_TX[1]=10;
Telegram_TX[2]=1;
Telegram_TX[3]=0;
Telegram_TX[4]=2;
Telegram_TX[5]=1;
Telegram_TX[6]=0;
Telegram_TX[7]=0;



if (opt1 == 's') Telegram_TX[7] = 1;

/* FASE 2 TRANSMISSAO */

NOB = 10;
BCS=0;
for (i=0;i<NOB;i++)
BCS = BCS ^ Telegram_TX[i];
BCS = BCS ^ ETX;

Byte_TX = DLE;
write(fd,&Byte_TX,1);
Byte_TX = STXeven;
write(fd,&Byte_TX,1);


for(i=0;i<NOB;i++)
   {
    if (Telegram_TX[i] == DLE)
      {
       Byte_TX = DLE;
       write(fd,&Byte_TX,1);
      }
    write(fd,&Telegram_TX[i],1);
   }

Byte_TX = DLE;
write(fd,&Byte_TX,1);
Byte_TX = ETX;
write(fd,&Byte_TX,1);
Byte_TX = BCS;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);
if (Byte_RX == ACK) contato = TRUE;
if (Byte_RX == RVI) contato = TRUE;
if (Byte_RX == NAK) contato = FALSE;
if (Byte_RX != ACK) contato = FALSE;

if (contato == TRUE) 
   {   
    Byte_TX = EOT;
    write(fd,&Byte_TX,1);
   }

/* FASE 1 RECEPCAO */

read(fd,&Byte_RX,1);

if (Byte_RX == ENQ)
   {
    Byte_TX = ACK;
    write(fd,&Byte_TX,1);
   }
else contato = FALSE;

read(fd,&Byte_RX,1);
if (Byte_RX == DLE) read(fd,&Byte_RX,1);

BCS = 0;

for(i=0;i<NOB;i++)
   {
    read(fd,&Telegram_RX[i],1);
    if (Telegram_RX[i] == DLE) read(fd,&Byte_RX,1);
   }

read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
     
Byte_TX = ACK;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);

for(i=0;i<NOB;i++) printf("Telegrama[%d] = %d\n<br>",i,Telegram_RX[i]);

}
