#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>

#define ENQ 0x05
#define ACK 0x06
#define WACK 0x0E
#define RVI 0x0F
#define NAK 0x15
#define DLE 0x10
#define STXeven 0x02
#define STXodd 0x82
#define ETX 0x03
#define EOT 0x04

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

main()
{
int fd, NOB, i;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX, contato, Telegram_TX[8], Telegram_RX[9], BCS;
time_t TimeSec;

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

/* FASE 1 TRANSMISSAO */

Byte_TX= ENQ;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);
printf("o byte recebido %d",Byte_RX);

if (Byte_RX == ACK) contato = TRUE;
else if (Byte_RX == ENQ)
       { 
        read(fd,&Byte_RX,1);
        if (Byte_RX == ACK) contato = TRUE;
        else contato = FALSE;
       }
     else contato = FALSE;

/* DEFININDO O TELEGRAMA A SER TRANSMITIDO */

Telegram_TX[0]=0; 
Telegram_TX[1]=8;
Telegram_TX[2]=1;
Telegram_TX[3]=0;
Telegram_TX[4]=45;
Telegram_TX[5]=1;
Telegram_TX[6]=0;
Telegram_TX[7]=0;

/* FASE 2 TRANSMISSAO */

NOB = 8;
BCS=0;
for (i=0;i<NOB;i++)
BCS = BCS ^ Telegram_TX[i];
BCS = BCS ^ ETX;

Byte_TX = DLE;
write(fd,&Byte_TX,1);
Byte_TX = STXeven;
write(fd,&Byte_TX,1);


for(i=0;i<NOB;i++)
   {
    if (Telegram_TX[i] == DLE)
      {
       Byte_TX = DLE;
       write(fd,&Byte_TX,1);
      }
    write(fd,&Telegram_TX[i],1);
    printf("Telegrama Sendo enviado\n");
   }

Byte_TX = DLE;
write(fd,&Byte_TX,1);
Byte_TX = ETX;
write(fd,&Byte_TX,1);
Byte_TX = BCS;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);
printf("o byte recebido %d",Byte_RX);
if (Byte_RX == ACK) contato = TRUE;
if (Byte_RX == RVI) contato = TRUE;
if (Byte_RX == NAK) contato = FALSE;
if (Byte_RX != ACK) contato = FALSE;

if (contato == TRUE) 
   {   
    printf("CONTATO OK! \n");
    Byte_TX = EOT;
    write(fd,&Byte_TX,1);
   }
else printf("SEM CONTATO! \n");

/* FASE 1 RECEPCAO */

printf("esperando ENQ do ROBO\n");
read(fd,&Byte_RX,1);
printf("ENQ do ROBO recebido\n");
printf("o byte recebido %d",Byte_RX);

if (Byte_RX == ENQ)
   {
    Byte_TX = ACK;
    write(fd,&Byte_TX,1);
   }
else contato = FALSE;

read(fd,&Byte_RX,1);
if (Byte_RX == DLE) read(fd,&Byte_RX,1);

BCS = 0;

for(i=0;i<9;i++)
   {
    read(fd,&Telegram_RX[i],1);
    if (Telegram_RX[i] == DLE) read(fd,&Byte_RX,1);
   }

read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
read(fd,&Byte_RX,1);
     
Byte_TX = ACK;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);

for(i=0;i<9;i++) printf("Telegrama[%d] = %d",i,Telegram_RX[i]);

}
