#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>

#define ENQ 0x05
#define ACK 0x06
#define WACK 0x0E
#define RVI 0x0F
#define NAK 0x15
#define DLE 0x10
#define STXeven 0x02
#define STXodd 0x82
#define ETX 0x03
#define EOT 0x04

#define TRUE 1;
#define FALSE 0;

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"

char STXevenTX, STXevenRX, FirstSend, FirstReceive;
/*---------------------------------------------------------------------*/
void InitADLP_10(void)
{
 STXevenTX = TRUE;
 STXevenRX = TRUE;
 FirstSend = TRUE;
 FirstReceive = TRUE;
}
/*---------------------------------------------------------------------*/
int TX_Phase1(void)
{
int fd;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX;

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

printf("executando fase1");
Byte_TX = ENQ;
write(fd,&Byte_TX,1);

read(fd,&Byte_RX,1);
if (Byte_RX == ACK) return 0;
if (Byte_RX == RVI) return 0;
if (Byte_RX == ENQ) 
   {
    read(fd,&Byte_RX,1);
    if (Byte_RX == ACK) return 0;
    else return -9;
   }
else return -9;
}
/*------------------------------------------------------------------------*/

int TX_Phase2(char* Telegram_TX)
{
int fd, i, NOB;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX, STX, BCS;

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

NOB = Telegram_TX[0]*0x100+Telegram_TX[1];
if (STXevenTX==TRUE) STX=STXeven;
else STX=STXodd;

BCS=0;
for(i=0;i<NOB;i++)
BCS = BCS^Telegram_TX[i];
BCS = BCS^ETX;

Byte_TX= DLE;
write(fd,&Byte_TX,1);
Byte_TX= STX;
write(fd,&Byte_TX,1);

for (i=0;i<NOB;i++)
   {
    if (telegram_TX[i]==DLE)
       {
        Byte_TX = DLE;
        write(fd,&Byte_TX,1);
       }
    Byte_TX = Telegram_TX[i];
    write(fd,&Byte_TX,1);
   }
Byte_TX= DLE;
write(fd,&Byte_TX,1);
Byte_TX= ETX;
write(fd,&Byte_TX,1);
Byte_TX= BCS;
write(fd,&Byte_TX,1);
 
read(fd,&Byte_RX,1);
if (Byte_RX == ACK) 
   {
    STXevenTX=!(STXevenTX);
    return 0;
    Byte_TX= EOT;
    write(fd,&Byte_TX,1);
   }
if (Byte_RX == RVI)
   {
    STXevenTX=!(STXevenTX);
    return 0;
    Byte_TX= EOT;
    write(fd,&Byte_TX,1);
   }
if (Byte_RX == NAK) return -2;
else return -9;
}
/*------------------------------------------------------------------------*/
int RX_Phase1(void)
{
int fd;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX;

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

printf("executando fase1-recep\n");
read(fd,&Byte_RX,1);
if (Byte_RX == ENQ)
   {
    Byte_TX=ACK;
    write(fd,&Byte_TX,1);
    STXevenRX = TRUE;
   }
else return -9;
}
/*------------------------------------------------------------------------*/
int RX_Phase2(char* Telegram_RX)
{
int fd, i;
struct termios oldtio, newtio, oldstdtio, newstdtio;
char Byte_TX, Byte_RX, Repetition, BCS;

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   

tcgetattr(fd,&oldtio);
newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | PARENB | CLOCAL | CREAD;
newtio.c_iflag = IGNPAR;
newtio.c_oflag = 0;
newtio.c_lflag = 0;
newtio.c_cc[VMIN]=1;
newtio.c_cc[VTIME]=0;   
tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);
tcsetattr(1,TCSANOW,&newtio);
tcgetattr(0,&oldstdtio);
tcgetattr(0,&newstdtio);
newstdtio.c_lflag &= ~(ICANON | ECHO);
tcsetattr(0,TCSANOW,&newstdtio);

read(fd,Byte_RX,1);
if (Byte_RX == DLE);
   {
    read(fd,Byte_RX,1);
    if (Byte_RX == STXeven)
       {
        if (STXevenRX == TRUE) Repetition=FALSE;
        else Repetition=TRUE;
       }
    if (Byte_RX == STXodd)
       {
        if (STXevenRX == TRUE) Repetition= FALSE;
        else Repetition = TRUE;
       }
    else return -9;
else return -1;
BCS=0;
i=0;
while(i<129)
   {
    read(fd,&ByteRX,1);
    if (Byte_RX != DLE)
       {
        Telegram_RX[i] = Byte_RX;
        BCS = BCS ^ Byte_RX;
       }
    else
       {
        read(fd,&ByteRX,1);
        if (Byte_RX == DLE) 
           {
            Telegram_RX[i] = Byte_RX;
            BCS = BCS ^ Byte_RX;
           }
        if (Byte_RX == ETX)
           {
            BCS=BCS^ETX;
            read(fd,&Byte_RX,1)
            if (Byte_RX == BCS)
            if (Repetition == False)
               {
                Byte_TX=ACK;
                write(fd,&Byte_TX,1);
                STXevenRX=!(STXevenRX);
                return 0;
               }
            else 
               {
                Byte_TX=ACK;
                write(fd,&Byte_TX,1);
                return 2;
               }
        else return -1;
i++;
}
   
/*------------------------------------------------------------------------*/
main()
{
int a;
char Telegrama[10];

a=TX_Phase1();
printf("O valor da fase 1 e: %d\n",a);
Telegram[0]=
Telegram[1]=
Telegram[2]=
Telegram[3]=
Telegram[4]=
Telegram[5]=
Telegram[6]=
Telegram[7]=
Telegram[8]=
Telegram[9]=
a=TX_Phase2(&Telegrama);
printf("O valor da fase 2 e: %d",a);
}
