#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

#include "nomad.h"
#include "util.h"
#include "cinematic.h"


int main(int argc, char *argv[])
{

	Nomad nomad;
	Coord pos, vel, acc, posInicial, posFinal;
	Cinematic cinematic;
    char mode = 0;



    if (argc < 4)
	{
        		cout << "Entre com a posicao desejada em x, y, rotacao" << endl;
		cout << "Exemplo:" << endl;
                	cout << "        TesteCinematic 0 100 0" << endl << endl;
                 	cout << " O comando acima move o robo 100 mm em Y" << endl;
		exit(0);
          }

          mode = N_AXIS_POSITION_RELATIVE;

          if (argc > 4)
                  	if (atoi(argv[4]) == 1)
                   {
                                cout << "Modo Absoluto de coordenadas" << endl;
                                mode = N_AXIS_POSITION_ABSOLUTE;
                   }


	cout << "Conectando com o Robo" << endl;
	if (nomad.Connect() == N_NO_ERROR)
		cout << "Conexo OK" << endl;
	else
		cout << "Erro ao Conectar com o Robo"  << endl;

	nomad.Speak("Conectado!");

        	cout <<"Movimento em X: " << atoi(argv[1]) << endl;
         	cout <<"Movimento em Y: " << atoi(argv[2]) << endl;
         	cout <<"Movimento Rotacional: " << atoi(argv[3]) << endl;

	pos.x	= atoi(argv[1]);
	pos.y 	= atoi(argv[2]);
	pos.rot	= atoi(argv[3]);



	vel.x 	= 500;
	vel.y 	= 500; //mm/s
	vel.rot	= 500;

	acc.x	= 20;
	acc.y	= 20;  //mm/s/s
	acc.rot	= 20;

    	posInicial = cinematic.GetPosition();
    	posFinal.x   = posInicial.x + pos.x;
    	posFinal.y   = posInicial.y + pos.y;
    	posFinal.rot = posInicial.rot + pos.rot;

	Coord zero;
	zero.x = zero.y = zero.rot = 0;
	cinematic.SetOdometry(zero);

	cinematic.SetVelocity(vel);
	cinematic.SetAccel(acc);
	cinematic.SetPosition(pos, mode);


 	while(cinematic.Moving())
   	{
                cout << "Posicao Atual: (" << cinematic.GetPosition().x << "," << cinematic.GetPosition().y << "," << cinematic.GetPosition().rot << ")" << endl;
				cout << "Odometro:      (" << cinematic.GetOdometry().x << "," << cinematic.GetOdometry().y << "," << cinematic.GetOdometry().rot << ")" << endl;
   	}

	/*if (posFinal.x != cinematic.GetPosition().x)
	{
		cout << "Erro na posicao X" << endl;
		cout << "posFinal = " << posFinal.x << endl;
		cout << "posAtual = " << cinematic.GetPosition().x << endl;
	}


	if (posFinal.y != cinematic.GetPosition().y)
	{
		cout << "Erro na posicao Y" << endl;
		cout << "posFinal = " << posFinal.y << endl;
		cout << "posAtual = " << cinematic.GetPosition().y << endl;
	}

	if (posFinal.rot != cinematic.GetPosition().rot)
	{
		cout << "Erro na Rotacao" << endl;
		cout << "posFinal = " << posFinal.rot << endl;
		cout << "posAtual = " << cinematic.GetPosition().rot << endl;
	}*/


   	if (nomad.Disconnect() == N_NO_ERROR)
		cout << "Desconexo OK" << endl;
	else
		cout << "Erro ao Desconectar-se do Robo"  << endl;

}
