#include <stdio.h>
#include "Nclient.h"
#include <unistd.h>
#include <curses/curses.h>
#include <string.h>

#define HOST	"lower"
#define PORT	7073

/****************************************************************************/

struct MyIR {
	struct N_Infrared	IR [N_MAX_SONAR_COUNT];
};

struct MapIR {
	int Reading[24];
};

struct MemMap {
	struct MapIR frame[10];
};

/****************************************************************************/

void ReadIRSet (int ss_number, struct MyIR *IRset);
void ShowIRSet (struct MyIR IRset); 		// Nao e usada
void MaxIRSet (struct MyIR IR1, struct MyIR IR2, 
	struct MyIR *minIR);
void MapIRSet (struct MyIR IR0, struct MyIR IR1, 
		struct MyIR IR2, struct MapIR *map);
void ShowMap (struct MapIR map); 		// Nao e usada
void MakeIRMap (struct MapIR *map);

/****************************************************************************/


int main() {

struct	N_RobotState	*state;
struct 	MapIR		map;
short			i,j;
char			s[80];

N_InitializeClient (HOST,PORT);
N_ConnectRobot (1);

initscr();

while (1) {

MakeIRMap (&map);

for (i=0;i<24;i++) {
	strcpy (s,"");
	for (j=0;j<map.Reading[i]*60.0/255.0;j++)
		strcat (s,"-");
	printw ("%d\t%s\n",map.Reading[i],s);
}

refresh();
usleep (1);
clear ();
}

endwin();

N_DisconnectRobot (1);
exit (0);

}

/****************************************************************************/

void MaxIRSet (struct MyIR IR1, struct MyIR IR2, 
	struct MyIR *minIR) {

int	i;

for (i=0;i<8;i++) {
	minIR->IR[i].Reading = IR1.IR[i].Reading >
		IR2.IR[i].Reading?IR1.IR[i].Reading:IR2.IR[i].Reading;
}

}

/****************************************************************************/

void ReadIRSet (int ss_number, struct MyIR *IRset) {

struct N_RobotState	*state;	
struct N_Infrared	*IR;
int			i;

state = N_GetRobotState (1);
IR = state->InfraredController.InfraredSet[ss_number].Infrared;
N_GetInfrared (1); // puts the updated IR information into the N_InfraredController structure

for (i=0;i<8;i++)
	IRset->IR[i].Reading=IR[i].Reading;

}

/****************************************************************************/

void ShowIRSet (struct MyIR IRset) {

int	i;

for (i=0;i<8;i++) 
	printf ("%d ",IRset.IR[i].Reading);
printf ("\n");

}

/****************************************************************************/

void MapIRSet (struct MyIR IR0, struct MyIR IR1, 
		struct MyIR IR2, struct MapIR *map) {

int	angle, i;

angle = 0;

// Esses lacos nao simetricos mostram os sensores de 
// de maneira nao simetrica com relacao ao SET.....    

for (i=6;i<8;i++) {
	map->Reading[angle] = IR2.IR[i].Reading;
	angle++;
}

for (i=0;i<8;i++) {
	map->Reading[angle] = IR0.IR[i].Reading;
	angle++;
}

for (i=0;i<8;i++) {
	map->Reading[angle] = IR1.IR[i].Reading;
	angle++;
}

for (i=0;i<6;i++) {
	map->Reading[angle] = IR2.IR[i].Reading;
	angle++;
}

}

/****************************************************************************/

void ShowMap (struct MapIR map) {

int 	i;

for (i=0;i<24;i++)
	printf ("%d ",map.Reading[i]);

printf ("\n");
}

/****************************************************************************/

void MakeIRMap (struct MapIR *map) {

struct	MyIR	ss,si,IR0,IR1,IR2;

ReadIRSet (0,&ss);
ReadIRSet (1,&si);
MaxIRSet (ss,si,&IR0); // guarda o Max em IR0
ReadIRSet (2,&ss);
ReadIRSet (3,&si);
MaxIRSet (ss,si,&IR1); // guarda o Max em IR1   
ReadIRSet (4,&ss);
ReadIRSet (5,&si);
MaxIRSet (ss,si,&IR2); // guarda o Max em IR2

MapIRSet (IR0,IR1,IR2,map);

}	
