/*
 * Swing.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
/*
 * This applet displays a single image twice,
 * once at its normal size and once much wider.
 */

public class ImageDisplayer {



    public static void main(String[] args) {

        ImagePanel imagePanel = new ImagePanel();

        JFrame f = new JFrame("ImageDisplayer");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

        f.getContentPane().add(imagePanel, BorderLayout.CENTER);
        f.setSize(new Dimension(1000,800));
        f.setVisible(true);

    }
}

class ImagePanel extends JPanel {
    Image image;

    public ImagePanel() {
        int w = 300;
	int h = 300;
	int[] pix = new int[w * h];
	int index = 0;
	for (int y = 0; y < h; y++) {
 		int red = (y * 255) / (h - 1);
    		for (int x = 0; x < w; x++) {
          		int blue = (x * 255) / (w - 1);
          		pix[index++] = (255 << 24) | (red << 16) | blue;
    		}
	}
	Image img = createImage(new MemoryImageSource(w, h, pix, 0, w));

	this.image = img;

    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g); //paint background

        //Draw image at its natural size first.
        g.drawImage(image, 0, 0, this); //85x62 image

        //Now draw the image scaled.
        g.drawImage(image, 305, 0, 600, 600, this);
    }
}

