package mapview;

import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Hashtable;

/**
 * Title:        Visualizador de Mapas de Ambiente
 * Description:  Visualiza os mapas de ambientes capiturados pelo programa em C++
 * Copyright:    Copyright (c) 2002
 * Company:      UnB
 * @author Paulo Roberto Correa Dutra e Marcio Moreira de Sousa
 * @version 1.0
 */

class Ponto
{
  public Ponto(int a, int b)
  {
    x = a;
    y = b;
  }

  public Ponto()
  {
  }

  public int x;
  public int y;
}

class PainelMap extends Panel {

  Vector points = new Vector();

  private boolean cl = false;

  public PainelMap()
  {
      setBackground(Color.white);
      setBounds(new Rectangle(4, 3, 391, 250));
      setLayout(null);
      repaint();
  }

  public void clear()
  {
    cl = true;
    repaint();
  }

  public void setPixel(int x, int y)
  {
    Ponto ponto = new Ponto(x, y);
    if (!points.contains(ponto))
      points.add(ponto);
    repaint();
  }


   public void paint(Graphics g) {

        int totalpoints = points.size();

	g.setColor(getForeground());
	g.setPaintMode();

        if (cl)
        {
            g.clearRect(this.getBounds().x, this.getBounds().y, this.getBounds().width, this.getBounds().height);
            cl = false;
        }
        else
        {

	  for (int i=0; i < totalpoints; i++) {
	      Ponto p = (Ponto)points.elementAt(i);
              g.setColor(Color.black);
    	      g.drawLine(p.x, p.y, p.x, p.y);
          }
        }

    }
}


public class telaprincipal extends JFrame {
  PainelMap painelMap = new PainelMap();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();

  Vector mapa = new Vector();

  public telaprincipal() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public static void main(String[] args) {
    telaprincipal telaprincipal1 = new telaprincipal();
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    jButton1.setText("Executar");
    jButton1.setBounds(new Rectangle(100, 266, 86, 27));
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });

    jButton2.setText("Limpar");
    jButton2.setBounds(new Rectangle(216, 266, 93, 27));
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });
    this.setDefaultCloseOperation(3);
    this.setResizable(false);
    this.setTitle("MapView");

    this.getContentPane().add(painelMap, null);
    this.getContentPane().add(jButton2, null);
    this.getContentPane().add(jButton1, null);


    this.setBounds(0,0,410,350);

    this.show();
  }

  void jButton1_actionPerformed(ActionEvent e) {

    for (int i=0; i< 100; i++)
    {
      for (int j=0; j<100; j++)
      {
        if (i+j == 77)
          painelMap.setPixel(i, j);
      }
    }

  }

  void jButton2_actionPerformed(ActionEvent e) {
    painelMap.clear();
  }


}