package navmap;

/**
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Paulo Roberto Correa Dutra & Marcio Moreira de Sousa
 * @version 1.0
 * <BR>Classe que faz a conexo entre os mtodos nativos e Java
 */

public class ConectorJava {

  /**
   * Implementaao do Singleton
   */
  private static final ConectorJava INSTANCE = new ConectorJava();
  /**
   * Construtor da classe  responsvel por carregar a biblioteca
   * Nativa que contem os mtodos nativos.
   */
  private ConectorJava() {
    try {
      //System.loadLibrary("makemap");
    } catch (Exception e){
      e.printStackTrace();
    }
  }

  /**
   * Retorna a Instancia do Conector Java
   * @return
   */
  public static ConectorJava getInstance( ) {
     return INSTANCE;
  }



  /**
   * Mtodo Nativo que captura o Mapa feito em C++
   * @return Matriz com os dados do Mapa
   */
  public native int[][] getMap();

  /**
   * Mtodo Nativo que captura o status das Bateris
   * @return Matriz com o valor da tenso nas 4 Baterias
   */
  public native float[] getBatteryStatus();

  /**
   * Mtodo Nativo para iniciar a conexo e Mapeamento do Nomad
   */
  public native void startNomad();

  /**
   * Mtodo Nativo para finalizar a conexo com o Nomad
   */
  public native void finishNomad();



}