package navmap;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;



/**
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Paulo Roberto Correa Dutra & Marcio Moreira de Sousa
 * @version 1.0
 * <BR> Classe que mostra o Mapa
 */

public class PainelMapa extends JPanel{


  private Image mapa;
  private ImageMapa imageMapa = new ImageMapa();

  public PainelMapa(MouseListener ml) {
    mapa = imageMapa.getImage();
    this.setBorder(BorderFactory.createLineBorder(Color.darkGray, 1));
    this.addMouseListener(ml);

    Thread me = new Thread(new AtualizaMapa());
    me.start();

  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g); //paint background
    int x = (int)this.getSize().getWidth()/2;
    int y = (int)this.getSize().getHeight()/2;

    x = (x > 300)?x-300:0;
    y = (y > 300)?y-300:0;

    g.drawImage(mapa, x, y,600,600,this);

  }


  public class AtualizaMapa implements Runnable{
    public void run(){
      while (true){
        try{
          Thread.sleep(1000);
          mapa = imageMapa.getImage();
          repaint();
        }catch(InterruptedException e){
          e.printStackTrace();
        }
      }
    }
  }


} // Fim da Classe PainelMapa


