package navmap;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * <p>Title: NavMap</p>
 * <p>Description: Navegao por Mapeamento</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Graco - UnB</p>
 * @author Paulo Roberto Correa Dutra & Marcio Moreira de Sousa
 * @version 1.0
 */

public class TelaPrincipal extends JFrame {
  private PainelInfo painelInfo;
  private PainelMapa painelMapa;
  private EventoAcao listener = new EventoAcao();
  private EventoMouse mouseListener = new EventoMouse();


  public TelaPrincipal(){
    try{
      jbInit();
    }catch(Exception ex){
      ex.printStackTrace();
    }

  }

  private void jbInit() throws Exception{

    /* Configuraes do PainelInfo */
    listener = new EventoAcao();
    painelInfo = new PainelInfo(listener);
    Dimension piDim = new Dimension(200, this.getHeight());
    painelInfo.setPreferredSize(piDim);
    this.setDefaultCloseOperation(3);

    /* Configuraoes do PainelMapa*/
    painelMapa = new PainelMapa(mouseListener);
    painelMapa.setPreferredSize(new Dimension(600,600));

    JScrollPane scrMapa = new JScrollPane();
    scrMapa.getViewport().add(painelMapa);

    //painelMapa.setSize(screenSize);
    this.getContentPane().setLayout(new BorderLayout());
    this.getContentPane().add(painelInfo, BorderLayout.WEST);
    this.getContentPane().add(scrMapa, BorderLayout.CENTER);
    this.setJMenuBar(new MenuPrincipal());
    this.setTitle("NavMap - Navegao por Mapeamento");
    this.addWindowListener(listener);

  }

  class EventoAcao extends WindowAdapter implements ActionListener{
      public void actionPerformed(ActionEvent event){
        if (event.getActionCommand().equalsIgnoreCase("conectar")){
          System.out.println("apertou botao Conectar");
        }

        if (event.getActionCommand().equalsIgnoreCase("desconectar")){
          System.out.println("apertou botao DesConectar");
        }


      }
  }

  class EventoMouse implements MouseListener{

         public void mouseExited(MouseEvent e){
         }
         public void mouseEntered(MouseEvent e){
         }

         public void mouseReleased(MouseEvent e){
           if (SwingUtilities.isLeftMouseButton(e))
           {
             int x = (int)painelMapa.getSize().getWidth()/2;
             int y = (int)painelMapa.getSize().getHeight()/2;

             x = (x > 300)?x-300:0;
             y = (y > 300)?y-300:0;

             x = e.getX() - x;
             y = e.getY() - y;

             System.out.println("mouseLeft in position (X,Y)" + x + "," + y);
             // Mandar o robo andar at a posiao clicada
           }
           else
             System.out.println("mouseRight in position (X,Y)" + e.getX() + "," + e.getY());
             // Manda o robo parar
         }

         public void mousePressed(MouseEvent e){
         }

         public void mouseClicked(MouseEvent e){
         }

  }


}