#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <string.h>
#include <math.h>

#include "nomad.h"
#include "util.h"
#include "sensonar.h"
#include "senir.h"
#include "mapa.h"
#include "cinematic.h"

#define CELULA_VAZIA    0
#define CELULA_OCUPADA  1
#define CELULA_SEMINFO -1
#define RAIO_ROBO 300 // mm

// Posicao Inicial do Robo em relacao ao referencia global em [mm]
#define m 600
#define n 500

// Variaveis Globais;

Sensor sensorValido[24];
SenIr ir;
SenSonar sonar;
Coord pos;
Cinematic cinematic;
Nomad nomad;
Mapa mapaEstatico;


void AtualizaSensores()
{

	long aux;
	double dx,dy;
	int lin, col;
 	int valor_cel;
	dx = dy = lin = col = 0;
	float scan;


	for (int i = 0; i < 8; i++  )
	{
		sensorValido[i].id = i;
		sensorValido[i].set = 0;
		sensorValido[i].valor = ir.Read(sensorValido[i]);

		sensorValido[i].set = 1;
		aux = ir.Read(sensorValido[i]);

		if ( aux < sensorValido[i].valor)
			sensorValido[i].valor = aux;

		// Neste ponto temos o menor valor do Infravermelho entre os Conjuntos 0,1
		if (sensorValido[i].valor == LONG_MAX)
		{
			// leitura do sonares
			sensorValido[i].set = 0;
			sensorValido[i].valor = sonar.Read(sensorValido[i]);

			sensorValido[i].set = 1;
			aux = sonar.Read(sensorValido[i]);

			if (aux < sensorValido[i].valor )
				sensorValido[i].valor = aux;

		}

		pos = cinematic.GetOdometry();

               	if (sensorValido[i].valor >= 3000)
        		valor_cel =  CELULA_VAZIA;
	        else
		        valor_cel = CELULA_OCUPADA;

		cout<<"--cone---"<<endl;
		for (scan=0; scan < 0.2618; scan+=0.0349)
		{
		  //Leitura do sensor em relacao ao referencial do robo
		  dx = cos(0.5236+(0.2618*i)+scan)*(sensorValido[i].valor + RAIO_ROBO);
		  dy = sin(0.5236+(0.2618*i)+scan)*(sensorValido[i].valor + RAIO_ROBO);
                /*
                	Transformacao de cordenadas em relacao ao referencial global
                	m e n translacao em x e y respec. do referencial do robo em relacao ao referencial global
                */

		  col = (int)((cos(pos.rot/1000)*dx - sin(pos.rot/1000)*dy + m + pos.x)/100);
		  lin = (int)((sin(pos.rot/1000)*dx + cos(pos.rot/1000)*dy + n + pos.y)/100);

		  col=col < 0 ? 0 : col;
		  lin=lin < 0 ? 0 : lin;

		  cout<<"D: "<< sensorValido[i].valor <<", (col,lin)= " << col << "," << lin << endl;

		  mapaEstatico.insEnvMap(col, lin, valor_cel);
		}

	}

	for (int i = 0; i < 8; i++  )
	{
		sensorValido[i+8].id = i;
		sensorValido[i+8].set = 2;
		sensorValido[i+8].valor = ir.Read(sensorValido[i+8]);

		sensorValido[i+8].set = 3;
		aux = ir.Read(sensorValido[i+8]);

		if ( aux < sensorValido[i+8].valor)
			sensorValido[i+8].valor = aux;

		if (sensorValido[i+8].valor == LONG_MAX)
		{
			// leitura do sonares
			sensorValido[i+8].set = 2;
			sensorValido[i+8].valor = sonar.Read(sensorValido[i+8]);

			sensorValido[i+8].set = 3;
			aux = sonar.Read(sensorValido[i+8]);

			if (aux < sensorValido[i+8].valor )
				sensorValido[i+8].valor = aux;

		}

		pos = cinematic.GetOdometry();

               	if (sensorValido[i+8].valor >= 3000)
        		valor_cel =  CELULA_VAZIA;
	        else
		        valor_cel = CELULA_OCUPADA;

		cout<< "--cone---" <<endl;
		for (scan=0; scan < 0.2618; scan+=0.0349)
		{
		  //Leitura do sensor em relacao ao referencial do robo
		  dx = cos(0.5236+(0.2618*(i+8))+scan)*(sensorValido[i+8].valor + RAIO_ROBO);
		  dy = sin(0.5236+(0.2618*(i+8))+scan)*(sensorValido[i+8].valor + RAIO_ROBO);
                /*
                	Transformacao de cordenadas em relacao ao referencial global
                	m e n translacao em x e y respec. do referencial do robo em relacao ao referencial global
                */

		  col = (int)((cos(pos.rot/1000)*dx - sin(pos.rot/1000)*dy + m + pos.x)/100);
		  lin = (int)((sin(pos.rot/1000)*dx + cos(pos.rot/1000)*dy + n + pos.y)/100);

		  col=col < 0 ? 0 : col;
		  lin=lin < 0 ? 0 : lin;

		  cout<<"D: "<< sensorValido[i].valor <<", (col,lin)= " << col << "," << lin << endl;


                  mapaEstatico.insEnvMap(col,lin, valor_cel);
		}


	}

	for (int i = 0; i < 8; i++  )
	{
		sensorValido[i+16].id = i;
		sensorValido[i+16].set = 4;
		sensorValido[i+16].valor = ir.Read(sensorValido[i+16]);

		sensorValido[i+16].set = 5;
		aux = ir.Read(sensorValido[i+16]);


		if ( aux < sensorValido[i+16].valor)
			sensorValido[i+16].valor = aux;

		if (sensorValido[i+16].valor == LONG_MAX)
		{
			// leitura do sonares
			sensorValido[i+16].set = 4;
			sensorValido[i+16].valor = sonar.Read(sensorValido[i+16]);

			sensorValido[i+16].set = 5;
			aux = sonar.Read(sensorValido[i+16]);

			if (aux < sensorValido[i+16].valor )
				sensorValido[i+16].valor = aux;

		}

                  pos = cinematic.GetOdometry();

               	if (sensorValido[i+16].valor >= 3000)
        		       valor_cel =  CELULA_VAZIA;
	         else
		       valor_cel = CELULA_OCUPADA;

		cout<<"--cone---"<<endl;
		for (scan=0; scan < 0.2618; scan+=0.0349)
		{
		  //Leitura do sensor em relacao ao referencial do robo
		  dx = cos(0.5236+(0.2618*(i+16))+scan)*(sensorValido[i+16].valor + RAIO_ROBO);
		  dy = sin(0.5236+(0.2618*(i+16))+scan)*(sensorValido[i+16].valor + RAIO_ROBO);
                /*
                	Transformacao de cordenadas em relacao ao referencial global
                */

		  col = (int)((cos(pos.rot/1000)*dx - sin(pos.rot/1000)*dy + m + pos.x)/100);
		  lin = (int)((sin(pos.rot/1000)*dx + cos(pos.rot/1000)*dy + n + pos.y)/100);

		  col=col < 0 ? 0 : col;
		  lin=lin < 0 ? 0 : lin;

		  cout<<"D: "<< sensorValido[i].valor <<", (col,lin)= " << col << "," << lin << endl;

		  mapaEstatico.insEnvMap(col,lin, valor_cel);
		}

	}
}


int main(int argc, char *argv[])
{


	if (nomad.Connect() == N_NO_ERROR)
		cout << "Conexo OK" << endl;
		else
		cout << "Erro ao Conectar com o Robo"  << endl;

		nomad.Speak("Conectado!");


	if (ir.Start() != N_NO_ERROR )
        	cout << "Erro ao iniciar o Sensor Infra Vermelho" << endl;


    	int fo[8] = {0,1,2,3,4,5,6,7};


    	for (int k = 0; k < 6; k++)
	{
		if ( sonar.Start(k, fo, 3 ) != N_NO_ERROR )
		cout << "Erro ao iniciar o Sonar " << k << endl;
	}

    	cout <<"Atualizando sensores..."<<endl;

	cinematic.ZeroRobot();
	AtualizaSensores();

	for(int j=100; j > 0; j--)
	{
		for (int i=0; i< 100 ; i++ )
				cout << mapaEstatico.envMap[i][j+400]; //<< "0";
		cout << endl;
	}

    	if (nomad.Disconnect() == N_NO_ERROR)
		cout << "Desconexo OK" << endl;
	else
		cout << "Erro ao Desconectar-se do Robo"  << endl;

}

