#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <math.h>
#include <list>

#include "nomad.h"
#include "util.h"
#include "sensonar.h"
#include "senir.h"
#include "mapa.h"
#include "cinematic.h"

#define CELULA_VAZIA    0
#define CELULA_OCUPADA  1
#define CELULA_SEMINFO -1
#define RAIO_ROBO 300 // mm

// Posicao Inicial do Robo em relacao ao referencia global em [mm]
#define m 600
#define n 3000

// Variaveis Globais;

Sensor sensorValido[24];
SenIr ir;
SenSonar sonar;
Coord pos;
Cinematic cinematic;
Nomad nomad;
Mapa mapaEstatico;
struct N_RobotState *state;

#define ANG 0.261799387799

void paint(long dist, int sensor_index)
{
	int col, lin;
	float i,dx,dy;


	for (i=sensor_index*ANG; i<sensor_index*ANG+ANG; i+=0.017453)
	{
		//col = (int)(dist+RAIO_ROBO)*cos(i)/100 + 250; // Mudar o 250 colocar a posicao atual do robo
		//lin = (int)(dist+RAIO_ROBO)*sin(i)/100 + 250;

		//obstaculo em relacao ao robo
		dx = (dist+RAIO_ROBO)*cos(i);
		dy = (dist+RAIO_ROBO)*sin(i);

		pos = cinematic.GetOdometry(state);

		//Transformacao de cordenadas em relacao ao referencial global
                //m e n translacao em x e y respec. do referencial do robo em relacao ao referencial global

		col = (int)((cos(pos.rot/1000)*dx - sin(pos.rot/1000)*dy + m + pos.x)/100);
		lin = (int)((sin(pos.rot/1000)*dx + cos(pos.rot/1000)*dy + n + pos.y)/100);

		col=col < 0 ? 0 : col;
		lin=lin < 0 ? 0 : lin;

		//cout<<"(col,lin)= " << col << "," << lin << std::endl;
		mapaEstatico.insEnvMap(col, lin, 1);

	}

}

void AtualizaSensores()
{
	long result;
	for (int i=0; i< 24; i++)
	{
		result = sonar.Read(state,i) <? ir.Read(state,i);
		paint(result, i);
	}
}


int main(int argc, char *argv[])
{

	if (nomad.Connect() == N_NO_ERROR)
		std::cout << "Conexo OK" << std::endl;
	else
		std::cout << "Erro ao Conectar com o Robo"  << std::endl;


	nomad.Speak("Connected!");


	state = (struct N_RobotState*)(malloc(sizeof(struct N_RobotState)));
	state = nomad.GetRobotState();

	if (ir.Start(state) != N_NO_ERROR )
        	std::cout << "Erro ao iniciar o Sensor Infra Vermelho" << std::endl;


    	int fo[8] = {0,1,2,3,4,5,6,7};


    	for (int k = 0; k < 6; k++)
	{
		if ( sonar.Start(state, k, fo, 3 ) != N_NO_ERROR )
		std::cout << "Erro ao iniciar o Sonar " << k << std::endl;
	}


	std::cout <<"Zerando Robo..."<< std::endl;
	cinematic.ZeroRobot(state);

	std::cout <<"Atualizando sensores..."<< std::endl;
	//AtualizaSensores();

	// Movendo por quatro pontos //

	Coord obj, vel, acc;
	obj.rot = 0;

	vel.x = 0;
	vel.y = 100;
	vel.rot = 0;

	acc.x = 100;
	acc.y = 100;
	acc.rot = 100;

	obj.x = 0;
	obj.y = 100;


	cinematic.ZeroRobot(state);
	printf("Posicao Inicial (%d,%d)\n",
			cinematic.GetOdometry(state).x,
			cinematic.GetOdometry(state).y);

/*
	std::cout << "Movimento com N_AXIS_POSITION_RELATIVE" << std::endl;
	cinematic.SetPosition(state, obj, vel, acc, N_AXIS_POSITION_RELATIVE);

	obj.y = -100;
	cinematic.SetPosition(state, obj, vel, acc, N_AXIS_POSITION_RELATIVE);

*/
	obj.y = 100;
	std::cout << "Movimento com N_AXIS_VELOCITY" << std::endl;


//	cinematic.SetPosition(state, obj, obj, obj, N_AXIS_VELOCITY);


	// Rotacao de 90 graus
	obj.x = 0;
	obj.y = 0;
	obj.rot = -(int)M_PI*1000/2;
	
	vel.x = 0;
	vel.y = 0;
	vel.rot = 1000;

	acc.x = 0;
	acc.y = 0;
	acc.rot = 1000;


	cinematic.SetPosition(state, obj, vel, acc, N_AXIS_POSITION_RELATIVE);

	obj.x = 0;
	obj.y = 500;
	obj.rot = 0;

	cinematic.SetPosition(state, obj, obj, obj, N_AXIS_POSITION_RELATIVE);
	printf("--> 1\n");

	cinematic.SetPosition(state, obj, vel, acc, N_AXIS_STOP);
	printf("--> 2\n");



	printf("Posicao Final (%d,%d)\n",
			cinematic.GetOdometry(state).x,
			cinematic.GetOdometry(state).y);



	std::cout << "Fim do movimento" << std::endl;






/*
	while (cinematic.GetPosition(state).y <= (cinematic.GetPosition(state).y + obj.y))
	{
		printf("Posicao Atual (%d,%d)\n",
			cinematic.GetPosition(state).x,
			cinematic.GetPosition(state).y);

		cinematic.SetVelocity(state, obj);
	}

	//while (cinematic.GetPosition(state).y != obj.y);

	cout << "Ponto 1" << std::endl;

	obj.x = 0;
	obj.y = 0;
	cinematic.SetPosition(state, obj, N_AXIS_VELOCITY);
	cout << "Ponto 2" << std::endl;

	obj.x = 0;
	obj.y = -1000;
	cinematic.SetPosition(statestd::end, obj, N_AXIS_POSITION_RELATIVE);
	cout << "Ponto 3" << std::endl;
*/

	/*
		 Objetivo = 500 mm para Norte
		 Velocidade = 100 mm/s
		 Aceleracao = 100 mm/s
	*/


	/***********************************************************/
	// Desconectando:
	/***********************************************************/
	sonar.StopAll(state);
/*
	for(int j=80; j > 0; j--)
	{
		for (int i=0; i< 50 ; i++ )
			cout << mapaEstatico.envMap[i][j]; //<< "0";
		cout << std::endl;
	}
*/
	if (nomad.Disconnect() == N_NO_ERROR)
		std::cout << "Desconexo OK" << std::endl;
	else
		std::cout << "Erro ao Desconectar-se do Robo"  << std::endl;




}

