#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

#include "nomad.h"
#include "util.h"
#include "cinematic.h"
#include "sensonar.h"
#include "senir.h"
#include "senbumper.h"
#include "mapa.h"

Sensor sensorValido[24];


void AtualizaSensores()
{
	SenIr ir;
	SenSonar sonar;
	long aux;

    if (ir.Start() != N_NO_ERROR )
         		cout << "Erro ao iniciar o Sensor Infra Vermelho" << endl;


	
    int fo[8] = {0,1,2,3,4,5,6,7};


    for (int k = 0; k < 6; k++)
		if ( sonar.Start(k, fo, 3 ) != N_NO_ERROR )
			cout << "Erro ao iniciar o Sonar " << k << endl;
 	


	for (int i = 0; i < 8; i++  )
	{
		sensorValido[i].id = i;
		sensorValido[i].set = 0;
		sensorValido[i].valor = ir.Read(sensorValido[i]);

		sensorValido[i].set = 1;
		aux = ir.Read(sensorValido[i]);

		if ( aux < sensorValido[i].valor)
			sensorValido[i].valor = aux; 

		// Neste ponto temos o menor valor do Infravermelho entre os Conjuntos 0,1
		if (sensorValido[i].valor == LONG_MAX)
		{
			// leitura do sonares
			sensorValido[i].set = 0;
			sensorValido[i].valor = sonar.Read(sensorValido[i]);
		
			sensorValido[i].set = 1;
			aux = sonar.Read(sensorValido[i]);

			if (aux < sensorValido[i].valor )
				sensorValido[i].valor = aux;
			
		}
	}

	for (int i = 0; i < 8; i++  )
	{
		sensorValido[i+8].id = i;
		sensorValido[i+8].set = 2;
		sensorValido[i+8].valor = ir.Read(sensorValido[i+8]);

		sensorValido[i+8].set = 3;
		aux = ir.Read(sensorValido[i+8]);

		if ( aux < sensorValido[i+8].valor)
			sensorValido[i+8].valor = aux; 

		if (sensorValido[i+8].valor == LONG_MAX)
		{
			// leitura do sonares
			sensorValido[i+8].set = 2;
			sensorValido[i+8].valor = sonar.Read(sensorValido[i+8]);
		
			sensorValido[i+8].set = 3;
			aux = sonar.Read(sensorValido[i+8]);

			if (aux < sensorValido[i+8].valor )
				sensorValido[i+8].valor = aux;
			
		}


	}

	for (int i = 0; i < 8; i++  )
	{
		sensorValido[i+16].id = i;
		sensorValido[i+16].set = 4;
		sensorValido[i+16].valor = ir.Read(sensorValido[i+16]);

		sensorValido[i+16].set = 5;
		aux = ir.Read(sensorValido[i+16]);


		if ( aux < sensorValido[i+16].valor)
			sensorValido[i+16].valor = aux; 

		if (sensorValido[i+16].valor == LONG_MAX)
		{
			// leitura do sonares
			sensorValido[i+16].set = 0;
			sensorValido[i+16].valor = sonar.Read(sensorValido[i]);
		
			sensorValido[i+16].set = 1;
			aux = sonar.Read(sensorValido[i+16]);

			if (aux < sensorValido[i].valor )
				sensorValido[i+16].valor = aux;
			
		}


	}




}


int main(int argc, char *argv[])
{

	Nomad nomad;
	Sensor sensor; 

         
	// Variaveis de sensoriamento
       SenSonar sonar;
       SenIr ir;
                 //	SenBumper bumper;


	// Variaveis de mapeamento
       	Mapa mapaEstatico; //, mapaDinamico;

        
	cout << "Conectando com o Robo" << endl;
	if (nomad.Connect() == N_NO_ERROR)
		cout << "Conexo OK" << endl;
	else
		cout << "Erro ao Conectar com o Robo"  << endl;

	nomad.Speak("Conectado!");

    // Criar o mapa esttico;

        /*	while (bumper.Read().id < 0)
                {
                 		cout << "Funcionando" << endl;

                }

                cout << "Batida no Sensor:(" << bumper.Read().set << "," << bumper.Read().id << ")" << endl;

        */

           //sonar 400 mm - 5000 mm
           //ir 0mm a 400 mm
			
       
/*
		for (sensor.set = 0; sensor.set < 6  ; sensor.set ++)
		{
			for(sensor.id = 0 ; sensor.id < 8 ; sensor.id ++ )	
			{
			 cout << "IR set: "<< sensor.set << " id: " << sensor.id << " -> " << ir.Read(sensor) << endl;
		    }

			cout <<"---------------------------------------------"<<endl;

		}
*/



	AtualizaSensores();

	int x,y = 0;

	//graus para radiano -> 3.14159265358979/180;
	
	for (int i=0;i<=23 ;i++ )
	 {
		cout <<"Sensor: "<< i <<" -> "<<sensorValido[i].valor<<endl; 
		if (sensorValido[i].valor == LONG_MAX)
		{
			sensorValido[i].valor = 0;
		}
		x = (int)(cos(0.6545+(0.2618*i))*(sensorValido[i].valor+300)/100);
		y = (int)(sin(0.6545+(0.2618*i))*(sensorValido[i].valor+300)/100);
		
		cout <<"x= "<< x << "," << "y= " << y << endl;
		
		if ((x < 25) || (y < 25))
		{		
			mapaEstatico.insEnvMap(x+25,25-y,1);	
		}  

	}

/*
	for (int j=22; j<28; j++)
	{
		for (int i=22; i< 28; i++)
		{
			mapaEstatico.insEnvMap(i, j, 3);
		}
	}

	
	for(int j=0; j < 50; j++)   
	{
		for (int i=0; i< 50 ; i++ )
				cout << mapaEstatico.envMap[i][j] << "0"; 
		cout << endl;
	}

*/

	
	

   	if (nomad.Disconnect() == N_NO_ERROR)
		cout << "Desconexo OK" << endl;
	else
		cout << "Erro ao Desconectar-se do Robo"  << endl;

}
