#include "senbumper.h"
#include <stdio.h>

/* --------------------------------------------------------------
 * Function: 	SenBumper::SenBumper and SenBumper::~SenBumper
 * Purpose: 	The constructor and destructor of SenBumper class
 * Arguments:	none
 * Return:	an instance of SenBumper class
 * --------------------------------------------------------------*/

SenBumper::SenBumper()
{
         sensor_ret.set = -1;
         sensor_ret.id  = -1;
}

SenBumper::~SenBumper(){}


/* --------------------------------------------------------------
 * Function: 	SenBumper::Read
 * Purpose: 	return the Bumper that was fired
 * Arguments:	*state : Robot State
 * Return:	Sensor : the index of sensor fired;
 * --------------------------------------------------------------*/


Sensor	SenBumper::Read(struct N_RobotState *state)
{
	for (int i=0; i<6 ; i++ )
	{

		N_GetBumper(1);
		for (int j=0; j<8 ;j++ )
		{
			if ( state->BumperController.BumperSet[i].Bumper[j].Reading > 0)
			{
				sensor_ret.set = i;
				sensor_ret.id = j;
				return sensor_ret;
			}
		}
	}

	return sensor_ret;

}

