#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <math.h>

#include "nomad.h"
#include "Nclient.h"

// Variavel global;
bool goal;

bool Rotacionando(N_RobotState *state)
{
	N_GetAxes(1);
	if (state->AxisSet.Axis[N_ROTATION].InProgress )
	{
        		return true;
	}

	return false;
}

void Rotacionar(N_RobotState *state, int ang, int vel, int acc)
{
	state->AxisSet.Global = FALSE;

	state->AxisSet.Axis[N_ROTATION].DataActive = TRUE;

	state->AxisSet.Axis[N_ROTATION].Mode = N_AXIS_POSITION_RELATIVE;

	// Convertendo graus para miliradianos
	state->AxisSet.Axis[N_ROTATION].DesiredPosition = (int)(ang*17.4532925199);

	state->AxisSet.Axis[N_ROTATION].DesiredSpeed = vel;

	state->AxisSet.Axis[N_ROTATION].Acceleration = acc;

	state->AxisSet.Axis[N_ROTATION].Update = TRUE;

	int error;
	if ( (error = N_SetAxes(1)) != N_NO_ERROR &&
	  error != N_AXES_NOT_READY)
	  {
		printf("Erro rotacionando o robo\n");
		exit(-1);
	  }
	while (Rotacionando(state));

}

void MoverParaFrente(N_RobotState *state, int vel, int acc)
{

	state->AxisSet.Global = FALSE;

	state->AxisSet.Axis[N_YTRANSLATION].DataActive = TRUE;

	state->AxisSet.Axis[N_YTRANSLATION].Mode = N_AXIS_VELOCITY;

	state->AxisSet.Axis[N_YTRANSLATION].DesiredSpeed = vel;

	state->AxisSet.Axis[N_YTRANSLATION].Acceleration = acc;

	state->AxisSet.Axis[N_YTRANSLATION].Update = TRUE;

	// Movendo
	int error;
	if ( (error = N_SetAxes(1)) != N_NO_ERROR &&
	  error != N_AXES_NOT_READY)
	  {
		printf("Erro movendo o robo\n");
		exit(-1);
	  }

}

void Parar(N_RobotState *state)
{
	state->AxisSet.Global = FALSE;

	state->AxisSet.Axis[N_XTRANSLATION].DataActive = TRUE;
	state->AxisSet.Axis[N_XTRANSLATION].Mode = N_AXIS_STOP;
	state->AxisSet.Axis[N_XTRANSLATION].DesiredSpeed = 0;
	state->AxisSet.Axis[N_XTRANSLATION].Acceleration = 0;
	state->AxisSet.Axis[N_XTRANSLATION].Update = TRUE;

	state->AxisSet.Axis[N_YTRANSLATION].DataActive = TRUE;
	state->AxisSet.Axis[N_YTRANSLATION].Mode = N_AXIS_STOP;
	state->AxisSet.Axis[N_YTRANSLATION].DesiredSpeed = 0;
	state->AxisSet.Axis[N_YTRANSLATION].Acceleration = 0;
	state->AxisSet.Axis[N_YTRANSLATION].Update = TRUE;

	state->AxisSet.Axis[N_ROTATION].DataActive = TRUE;
	state->AxisSet.Axis[N_ROTATION].Mode = N_AXIS_STOP;
	state->AxisSet.Axis[N_ROTATION].DesiredSpeed = 0;
	state->AxisSet.Axis[N_ROTATION].Acceleration = 0;
	state->AxisSet.Axis[N_ROTATION].Update = TRUE;

	// Movendo
	int error;
	if ( (error = N_SetAxes(1)) != N_NO_ERROR &&
	  error != N_AXES_NOT_READY)
	  {
		printf("Erro parando o robo\n");
		exit(-1);
	  }

}


void Zerar(N_RobotState *rs)
{
  rs->AxisSet.Global = TRUE;
  rs->AxisSet.Axis[N_XTRANSLATION].Mode = N_AXIS_POSITION_ABSOLUTE;
  rs->AxisSet.Axis[N_XTRANSLATION].DesiredPosition = 0;
  rs->AxisSet.Axis[N_XTRANSLATION].DesiredSpeed = 0;
  rs->AxisSet.Axis[N_XTRANSLATION].Acceleration = 0;
  rs->AxisSet.Axis[N_XTRANSLATION].Update = TRUE;
  rs->AxisSet.Axis[N_YTRANSLATION].Mode = N_AXIS_POSITION_ABSOLUTE;
  rs->AxisSet.Axis[N_YTRANSLATION].DesiredPosition = 0;
  rs->AxisSet.Axis[N_YTRANSLATION].DesiredSpeed = 0;
  rs->AxisSet.Axis[N_YTRANSLATION].Acceleration = 0;
  rs->AxisSet.Axis[N_YTRANSLATION].Update = TRUE;
  rs->AxisSet.Axis[N_ROTATION].Mode = N_AXIS_POSITION_ABSOLUTE;
  rs->AxisSet.Axis[N_ROTATION].DesiredPosition = 0;
  rs->AxisSet.Axis[N_ROTATION].DesiredSpeed = 0;
  rs->AxisSet.Axis[N_ROTATION].Acceleration = 0;
  rs->AxisSet.Axis[N_ROTATION].Update = TRUE;

  int error;
  if ((error = N_SetAxes(1)) != N_NO_ERROR)
  {
    fprintf(stderr, "Error setting axes to zero (%d).\n", error);
    exit(-1);
  }

  /* zero the integrated configuration */
  rs->Integrator.x = 0;
  rs->Integrator.y = 0;
  rs->Integrator.Rotation = 0;
  if ((error = N_SetIntegratedConfiguration(1)) != N_NO_ERROR)
  {
    fprintf(stderr, "Error zeroing (%d).\n", error);
    exit(-1);
  }

}

int VerificaPosicao(N_RobotState *state, int x, int y)
{
	int ang;

	//Supor 4 pontos de trajetoria (quadrado)
	int trajetoria[4][2] = {{0,500},{500,500},{500,0},{0,0}};

	N_GetIntegratedConfiguration(1);

	if ((state->Integrator.x == x) && (state->Integrator.y == y))
	{
		goal = true;
		return 0;
	}


	for (int i=0; i < 4; i++)
	{
		if ( ((int)(trajetoria[i][1]/10) == (int)(state->Integrator.x/10)) &&
		     ((int)(trajetoria[i][2]/10) == (int)(state->Integrator.y/10)) )
		{
			printf("--Rotacionando--\n");
			ang = 90;
		}
	}


	return ang;
}


int main(int argc, char *argv[])
{
	Nomad nomad;

	if (nomad.Connect() == N_NO_ERROR)
		std::cout << "Conexo OK" << std::endl;
	else
		std::cout << "Erro ao Conectar com o Robo"  << std::endl;


	nomad.Speak("Connected!");

	int goalX, goalY;
	printf("Entre com a coordenda de destino\n");

	std::cin >> goalX >> goalY;


	struct N_RobotState *state = (struct N_RobotState*)(malloc(sizeof(struct N_RobotState)));
	state = nomad.GetRobotState();

	Zerar(state);

	int ang=0;
	bool goal = false;
	while(!goal)
	{
		MoverParaFrente(state, 200, 400);
		ang = VerificaPosicao(state, goalX, goalY);
		if (ang!= 0) Rotacionar(state, ang, 500, 250);
	}
	Parar(state);

	nomad.Disconnect();

}

