#include <dos.h>

// Classe que define a interface com o motor
//
// Rotinas utilizadas pela classe Motor (motor.C)
//
// Este programa realiza a comunicao entre o programa motor.C e o
// sistema operacional DOS.

#define		DATA	0x378
#define		STATUS	DATA+1
#define		CONTROL	DATA+2

class Interface {

	private:

		int porta;

	public:
			Interface ();		// Construtor
		       ~Interface ();		// Destrutor
		void	send (int dado);	// Envia dado ao dispositivo
		void 	sendc (int dado);	// Envia dado ao dispositivo
		int	get (void);		// Recebe dado do disp.
		void    waiting (int tempo);	// Espera o tempo definido

};

     Interface :: Interface ()

{
}

     Interface :: ~Interface ()

{
}

// As duas rotinas abaixo devem manter seu nome na versao para Linux.
// O conteudo evidentemente vai mudar...

void Interface :: send (int dado)

{
	outportb (DATA,dado);
}

void Interface :: sendc (int dado)

{
	outportb (CONTROL,dado);
}

int  Interface :: get (void)

{
	return inportb (STATUS);
}

void Interface :: waiting (int tempo)

{
	delay (tempo);
}

