/*
 Este programa faz a implementao dos objetos contidos no sistema de 
 gravao de CD-R. Ele est composto pelos seguintes objetos:

 Brutos		-	Representa o palete de peas brutas
 Acabados	- 	representa o palete de peas acabadas
 Gravador	- 	representa o gravador de CD-R
 THU		-	representa o mecanismo manipulador
 Garra		- 	representa a garra
 Gerenciador	- 	implementa o gerenciador da FMS.

*/

#include <stdio.h>

#define OK	0
#define ERRO	-1
#define FALTA	-2
#define CHEIO	-3
#define SIM	0
#define NAO	-1


// Esta classe simula o funcionamento da palete de CD-R brutos.
// Falta implementar o comando atravs dos motores de passo ou outro 
// mecanismo..


class Brutos {

	private:

		int CDS,max;

	public:

		Brutos (void);
V		Brutos (int N);
		int SaiCD (void);
		int EntraCD (void);
		void Quantos (void);
};

Brutos :: Brutos (void)

{
	CDS = max = 50;
}

Brutos :: Brutos (int N)

{
	CDS = max = N;
}

int Brutos :: SaiCD (void)

{
	CDS--;
//	Aqui entra o comando para o movimento da palete...
	if (CDS < 1) {
		return FALTA;
		}
	return OK;
}

int Brutos :: EntraCD (void)

{
	CDS = max;
	return OK;
}

void Brutos :: Quantos (void)

{
	printf ("%d",CDS);
}

// Esta classe simula o funcionamento da palete de CD-R acabados.
// Falta a implementao fsica do sistema...


class Acabados {

	private:
		
		int CDS,max;

	public:

		Acabados (void);
		Acabados (int N);
		int EntraCD (void);
		int SaiCD (void);
		void Quantos (void);

};

Acabados :: Acabados (void)

{
	CDS = 0;
	max = 50;
}

Acabados :: Acabados (int N)

{
	CDS = 0;
	max = N;
}

int Acabados :: EntraCD (void)

{
	if (CDS < max) {
		CDS++;
		if (CDS = max) {
			return CHEIO;
			}
		else
			return OK;
		}
}

int Acabados :: SaiCD (void)

{
	CDS = 0;
	return OK;
}

void Acabados :: Quantos (void)

{
	printf ("%d",CDS);
}



// Esta classe implementa o controle do gravador
// Falta a implementao do acesso ao programa que realiza a gravao, 
// abertura e fechamento do drive...


class Gravador {

	private:

		int CD,aberto;

	public:

		Gravador (void);
		Gravador (int estado);
		int Abrir (void);
		int Fechar (void);
		int Gravar (void);

}

Gravador :: Gravador (void)

{
	CD = NAO;
	aberto = NAO;
}

Gravador :: Gravador (int estado)

{
	aberto = estado;
}

int Gravador :: Fechar (void)

{
int valor;

	if (aberto == SIM) {

// Aqui ocorre a chamada a funcao mount para fechar o gravador, sendo 
// recebido um valor para ser retornado pela rotina...
// Deve-se ter aqui um modo de o cd reconhecer a presenca do CD-R...
		return valor;
	}
	else
		return ERRO;
}

int Gravador :: Abrir (void)

{
int valor;

	if (aberto == NAO) {

// Aqui ocorre a chamada a funcao umount ou eject para abrir o gravador

		return valor;
	}
	else
		return ERRO;
}

int Gravador :: Gravar (void)

{
int valor;

	if ((aberto == NAO) && (CD = SIM))
		{

// Aqui ocorre a chamada ao programa que realiza a gravacao do CD-R, 
// provavelmente usando a funcao "system()"...

		return valor;
	}
	else
		return ERRO;
}

// Esta classe implementa a movimentacao do mecanismo manipulador atraves da
// classe (ja existente) Motor...

#include <Interfac.C>
#include <Motor.C>

class THU : Motor

{
	private:
		int X,Y;		// Posicao atual
		float XR,YR;		// Relacao de movimentos
		int x [10],y [10];	// pontos de precisao que o 
					// manipulador passa...

	public:
		THU (void);
		THU (int xp [10], int yp [10]);
		void Def_Movimentacao (float xr,float yr);
		void Def_Ponto (int n,int xp,int yp);
		void Onde (int *xp,int *yp);
		int  MoverXY (int xp,int yp);
		int  MoverP (int ponto);
};

THU :: THU (void)

{
// Aqui ha' o comando para o manipulador zerar seu posicionamento (ZM)

}

THU :: THU (int xp [10],int yp [10])

{
int n;

// Aqui ha' o comando para o manipulador zerar seu posicionamento (ZM)

	for (n = 0;n < 10;n++) {
		x [n] = xp [n];
		y [n] = yp [n];
		}
}

void THU :: Def_Movimentacao (float xr, float yr);

{
	XR = xr;
	YR = yr;
}

void THU :: Def_Ponto (int n,int xp,int yp)

{
	x [n] = xp;
	y [n] = yp;
}

void THU :: Onde (int *xp,int *yp)

{
	*xp = X;
	*yp = Y;
}

int THU :: MoverXY (int xp,int yp)

{
int dX,dY;			// Deslocamentos em x e y;
class Motor horiz,vert

	dX = xp - X;		// movimentos relativos
	dY = yp - Y;

	if (dX != 0) {
		horiz.set (1);		// ver arquivos Motor.C e Motor.txt
		horiz.precision (1.8);
		horiz.delay (20);
		horiz.sstep();
		horiz.turn (dX * XR);
		horiz.off ();
		}

	if (dY != 0) {
		vert.set (2);
		vert.precision (1.8);
		vert.delay (20);
		vert.sstep ();
		vert.turn (dY * YR);
		vert.off ();
		}

	return OK;

// observao: a rotina acima no faz verificao de erro por sensores...
}

int THU :: MoverP (int ponto)

{
	MoverXY (x [ponto],y [ponto]);
}


// Esta classe implementa o mecanismo de controle da Garra, atravs do 
// comando de um indutor...

class Garra

{
	private:

		int Aberta;

	public:

		Garra (void);
		int Abrir (void);
		int Fechar (void);
		int Estado (void);
};

Garra :: Garra (void)

{
	Aberta = SIM;		// estado inicial da garra com indutor desligado
}

int Garra :: Abrir (void)

{
// Aqui insere-se o comando para desligar o indutor

	Aberta = SIM;
	return OK;
}

int Garra :: Fechar (void)

{
// Aqui insere-se o comando para ligar o indutor

	Aberta = NAO;
	return OK;
}

int Garra :: Estado (void)

{
	return Aberta;
}

// Classe gerenciador, que utiliza as classes criadas acima para o
// gerenciamento do sistema como um todo...

#define OK	       	0		// Ok.
#define Err_Falta_CD	-1		// Falta CD na palete
#define Err_THU_X	-2		// Erro posicionamento horizontal
#define Err_THU_Y	-3		// Erro posicionamento vertical
#define Err_CD_Grav	-4		// Falta CD no gravador
#define Err_CD		-5		// CD gravado incorretamente

class Gerenciador

{

	private:

		int gravados;
		char[30]  nomes[50];

	public:

		Gerenciador ();

		int ligar (void);			// inicio sem erro
		int ligar (int posicao);		// inicio apos erro
		void nome_CD (int n,char* nome);	// da' nome
		void emergencia (int erro);		// tenta resolver erro

};

Gerenciador :: Gerenciador ()

{
	gravados = 0;
}

void Gerenciador :: nome_CD (int n,char* nome)

{
	strcpy (nome,nomes[n]);
}

int Gerenciador :: ligar (void)

{
// Declaracao das variaveis associadas aos sistemas do manipulador

class Brutos brutos;
class Acabados acabados;
class THU thu;
class Garra garra;
class Gravador gravador;

// Aqui coloca-se o processo normal do sistema para o seu funcionamento
// de acordo com o modelo em Redes de Petri, com a devida verificacao dos
// erros



}




// Aqui tera' efeito o programa de controle do processo de manufatura

int main (void)

{
	class Gerenciador gerente;

	gerente.inicio();
	gerente.fim();

	return 0;
}
