#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <asm/io.h>
/*

class Interface
versao para Linux / Unix

A classe Interface prove uma base de comunicacao para a classe Motor 
controlar um motor de passo ligado a porta paralela

Esta implementacao usa o comando de acesso direto a porta paralela "outb",
e deve ser usado pelo programa com acesso de ROOT.

*/

#define DATA 	0x378		/* LPT 1 */
#define STATUS	DATA+1
#define CONTROL	DATA+2

class Interface {

	private:

		int porta;

	public:
			Interface ();		// construtor padrao
			Interface (int p);	// construtor definindo porta
			~Interface ();		// destrutor
		void 	send (int n);
		void 	sendc (int n);
		int	get  (void);
		void 	waiting (int t);
};

	Interface :: Interface ()

// Construtor abre o acesso a porta paralela do computador

{
	porta = DATA;

/*	if (setuid (503))
		{
		perror ("setuid");
		exit (1);
		}
	printf ("teste"); */
	if (ioperm (porta,3,1))
		{
		perror ("ioperm");
		exit (1);
		}
}

/*	Interface :: Interface (int p);

// Construtor abre o acesso a porta definida pelo usuario

{
	porta = p;
	if (ioperm (porta,3,1))
		{
		perror ("ioperm");
		exit (1);
		}
}

*/
	Interface :: ~Interface ()

// Destrutor que fecha o acesso a porta paralela do computador

{
	if (ioperm (porta,3,0))
		{
		perror ("ioperm");
		exit (1);
		}

}

void Interface :: send (int n)

// Envia o inteiro n para a porta paralela

{
	outb (n,porta);
}

void Interface :: sendc (int n)

{
	outb (n,porta+2);
}

int Interface :: get (void)

// Recebe o inteiro da porta paralela no endereco de status

{
	return inb (porta+1);
}

void Interface :: waiting (int t)

// Faz uma interrupcao de t milisegundos no sistema

{
	usleep (t*1000);
}
