#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

/*
#include "interface.c"
#include "motor.c"
*/

/* Definicoes para os motores */

#define	MOTOR_VER	1
#define  MOTOR_HOR         2

/* Definicoes para os sensores */

#define SENSOR_HE	0
#define SENSOR_HC	0
#define SENSOR_VS	0
#define SENSOR_VI	0

/* Definicoes para retorno de rotinas */

#define OK	0
#define ERRO	-1

/* Definicoes para retorno do processo */

#define	ZM	0
#define	DB	1
#define	SB	2
#define	PG	3
#define	DG	4
#define	GR	5
#define	SG	6
#define	PA	7
#define	DA	8
#define	SA	9
#define	PZ	10

/* Definicoes para parametros por comando de linha */

#define ERRO		-1
#define INICIAR		0
#define RECUPERAR       1 
#define POSICOES        2
#define SENSORES        3
#define MOTORES		4
#define LISTAR		5
#define HELP            6

/* Rotina que le o arquivo de processo existente retornando o numero de
   CDs no processo */

int getncd (char *filename)

{
FILE *file;
char n_cds[3];

     file = fopen (filename,"rt");
     if (file == NULL) {
              printf ("\nError loading file \"%s\".\nProgram terminated.\n",
                     filename);
              exit (0);
              }
     fscanf (file,"%s",n_cds);
     fclose (file);
     return atoi (n_cds);
}

/* Rotina que transforma uma diferenca entre tempos dada por difftime() em
string no tipo minutos:segundos */

void diffstr (long diff)

{
	printf ("%.2d:%.2d",diff / 60,diff % 60);
}

/* Rotina para listar eventos de um processo */

void listar (char *filename)

{
FILE *file;
char str[80];
int n_cds,ncd,time_f;
long num,time1,time2,timet;

char *mens[11] =
{"ZM ","DB ","SB ","PG ","DG ","GR ","SG ","PA ","DA ","SA ","PZ "};

	time1 = time2 = timet = 0;
	ncd = 0;
	time_f = 0;

	file = fopen (filename,"rt");
	if (file == NULL) {
              printf ("\nError loading file \"%s\".\nProgram terminated.\n",
                     filename);
              exit (0);
              }
	fscanf (file,"%s",str);
	printf ("\nTotal number of CDs in process: %s\n",str);
	n_cds = atoi (str);
	while (fscanf (file,"%s",str) >= 0) {
		num = atoi (str);	
	
		if (num <= 10) {
			printf ("%s",mens[num]);
		}
		else {
			time_f++;
			if (time_f == 1) {
				time1 = num;
				ncd++;
				printf ("\nCompleted steps for CD #%d: ",ncd);
			}
			if (time_f == 2) {
				time2 = num;
				time1 = difftime (time2,time1);
				printf ("\nElapsed time: ");
				diffstr (time1);
				printf ("\n");
				timet += time1;
				time_f = 0;
			}
		}



	}

	if (time_f == 1) {
		printf ("\nAn error ocurred at CD #%d in process %s\n\n",
			ncd,mens[1+ncd]);
		ncd--;
		printf ("Remains %d CDs to be processed.\n",n_cds-ncd);
	}

	printf ("Average process time: ");
	diffstr (timet / ncd);
	printf ("\n\n");	
	
	fclose (file);
}

/* Rotina para iniciar o processo */

void iniciar (char *filename)

{
FILE *file;
char n_cds[3];
int step,ncd,curr_cd,erro;
long time1,time2;

     file = fopen (filename,"r+");
     if (file == NULL) {
              printf ("\nError loading file \"%s\".\nProgram terminated.\n",
                     filename);
              exit (0);
              }
     fscanf (file,"%s\n",n_cds);
     ncd = atoi (n_cds);

     erro = 0;
     curr_cd = 1;

     while ((curr_cd < ncd) && (erro == 0)) {

	time (&time1);
	fprintf (file,"%ld\n",time1);	

	step = 0;
	while ((step <= 10) && (erro == 0)) {
		switch (step) {
			case ZM:
				break;
			case DB:
				break;
			case SB:
				break;
			case PG:
				break;
			case DG:
				break;
			case GR:
				break;
			case SG:
				break;
			case PA:
				break;
			case DA:
				break;
			case SA:
				break;
			case PZ:
				break;
			}
		if (erro == 0)
			fprintf (file,"%d\n",step);
		step++;
		}

	time (&time2);
	fprintf (file,"%ld\n",time2);

	curr_cd++;
	}


     fclose (file);
}




/* Rotina para help de comando de linha */

void help (void)

{
	printf ("\nCommand line options:\n\n");
	printf ("-i [filename]\tInitializes a new process log.\n");
	printf ("-r [filename]\tRecover an older process.\n");
	printf ("-p\t\tInitializes positions.\n");
	printf ("-s\t\tSensors testing.\n");
	printf ("-m\t\tMotors testing.\n");
	printf ("-l [filename]\tLists process events.\n");
	printf ("-h\t\tThis help!\n\n");
         printf ("Use no parameters to enter into interactive mode. (not implemented yet!)\n");
         printf ("See the documentation file for further informations.\n");
}
	

/* Rotina que reconhece parametros passados por comando de linha */

int parametro (int argc,char *argv [],char *filename)

{

int result = ERRO;

	if (strcmp (argv [1],"-i") == 0) {
		if (argc > 2) {
			strcpy (filename,argv [2]);
			result = INICIAR;
			}
		else {
			printf ("\nError: Filename required.\n");
			help ();
			exit (0);
			}
		}

	if (strcmp (argv [1],"-r") == 0) {
                if (argc > 2) {
                        strcpy (filename,argv [2]);
			result = RECUPERAR;
			}
                else {
                        printf ("\nERROR: Filename required.\n");
                        help ();
			exit (0);
                        }
                }      

	if (strcmp (argv [1],"-p") == 0)
		result = POSICOES;		
         
	if (strcmp (argv [1],"-s") == 0)
		result = SENSORES;

	if (strcmp (argv [1],"-m") == 0)
		result = MOTORES;

	if (strcmp (argv [1],"-l") == 0) {
                if (argc > 2) {
                        strcpy (filename,argv [2]);
			result = LISTAR;
			}
                else {
                        printf ("\nERROR: Filename required.\n");
			help ();
			exit (0);
                        }
                }      

	if (strcmp (argv [1],"-h") == 0) {
                result = HELP;
                }

	return result;
}

/* Rotina que chama uma tarefa do programa de acordo com o lido nos parametros
de linha */

void choose_order (int order,char *name)

{
int ncd;

       switch (order) {
               case INICIAR:
                    ncd = getncd (name);
		    iniciar (name);
                    break;
               case RECUPERAR:
                    break;
               case POSICOES:
                    break;
               case SENSORES:
                    break;
               case MOTORES:
                    break;
               case LISTAR:
		    listar (name);
                    break;
               case HELP:
                    help ();
                    break;
               case ERRO:
                    printf ("\nInvalid parameter.\n");
                    help ();
                    break;
        };
}

int main (int argc,char *argv [])

{
char name[80];
int order;

        if (argc > 1) {
		order = parametro (argc,argv,name);
                  choose_order (order,name);
                  }
        return 0;
}
