 #include <dos.h>

#define		DATA	0x378
#define		STATUS	DATA+1
#define		CONTROL	DATA+2

int porta;

void	send (int dado);	/* Envia dado ao dispositivo */
void 	sendc (int dado);	/* Envia dado ao dispositivo */
int	get (void);		/* Recebe dado do disp.      */
void    waiting (int tempo);	/* Espera o tempo definido   */

void send (int dado)

{
	outportb (DATA,dado);
}

void sendc (int dado)

{
	outportb (CONTROL,dado);
}

int  get (void)

{
	return inportb (STATUS);
}

void waiting (int tempo)

{
	delay (tempo);
}


int motor1_s [4] = {0x01,0x02,0x04,0x08},
    motor2_s [4] = {0x10,0x20,0x40,0x80},
    motor1_d [4] = {0x09,0x03,0x06,0x0C},
    motor2_d [4] = {0x90,0x30,0x60,0xC0};

int	numero,intervalo,
        tipo_excitacao,
	excitacao [4],
	ultima_excitacao;
float	precisao;

void	set (int n);		/* define o motor usado */
void 	precision (float p);	/* define a precisao do motor */
void 	sdelay (int tempo);	/* define o intervalo entre passos */
void 	turn (int angle);	/* gira angulo */
void	wait (int time);	/* espera tempo excitado */
void	sstep (void);		/* define excitacao simples */
void	dstep (void);		/* define excitacao dupla */
void    off (void);		/* desliga a excitacao do motor */

void set (int n)

{	numero = n;
	if (numero == 1)
		ultima_excitacao = 0xF0 & ultima_excitacao;
	if (numero == 2)
		ultima_excitacao = 0x0F & ultima_excitacao;

	if (tipo_excitacao)
	   dstep ();
	else
	   sstep ();
}

void sstep (void)

{
	if (numero == 0) {
		excitacao [0] = motor1_s [0] | motor2_s [0];
		excitacao [1] = motor1_s [1] | motor2_s [1];
		excitacao [2] = motor1_s [2] | motor2_s [2];
		excitacao [3] = motor1_s [3] | motor2_s [3]; }
	if (numero == 1) {
		excitacao [0] = motor1_s [0] | ultima_excitacao;
		excitacao [1] = motor1_s [1] | ultima_excitacao;
		excitacao [2] = motor1_s [2] | ultima_excitacao;
		excitacao [3] = motor1_s [3] | ultima_excitacao; }
	if (numero == 2) {
		excitacao [0] = motor2_s [0] | ultima_excitacao;
		excitacao [1] = motor2_s [1] | ultima_excitacao;
		excitacao [2] = motor2_s [2] | ultima_excitacao;
		excitacao [3] = motor2_s [3] | ultima_excitacao; }
	tipo_excitacao = 0;
}

void dstep (void)

{
	if (numero == 0) {
		excitacao [0] = motor1_d [0] | motor2_d [0];
		excitacao [1] = motor1_d [1] | motor2_d [1];
		excitacao [2] = motor1_d [2] | motor2_d [2];
		excitacao [3] = motor1_d [3] | motor2_d [3];  }
	if (numero == 1) {
		excitacao [0] = motor1_d [0] | ultima_excitacao;
		excitacao [1] = motor1_d [1] | ultima_excitacao;
		excitacao [2] = motor1_d [2] | ultima_excitacao;
		excitacao [3] = motor1_d [3] | ultima_excitacao; }
	if (numero == 2) {
		excitacao [0] = motor2_d [0] | ultima_excitacao;
		excitacao [1] = motor2_d [1] | ultima_excitacao;
		excitacao [2] = motor2_d [2] | ultima_excitacao;
		excitacao [3] = motor2_d [3] | ultima_excitacao;}
	tipo_excitacao = 1;
}


void off (void)

{
	ultima_excitacao = 0x00;
	send (0x00);
}

void precision (float p)

{
	precisao = p;
}

void sdelay (int tempo)

{
	intervalo = tempo;
}

/*

Esta rotina possui passo de 7.2 graus, pois efetua 4 passos de uma vez...

void turn (int angle)

{
	int ciclos,girando;
	class Interface porta;

	ciclos = (int) (angle / precisao);
	if (ciclos > 0) {
		for (girando = 0;girando < ciclos;girando++) {
			porta.send (excitacao [0]);
			porta.waiting (intervalo);
			porta.send (excitacao [1]);
			porta.waiting (intervalo);
			porta.send (excitacao [2]);
			porta.waiting (intervalo);
			porta.send (excitacao [3]);
			porta.waiting (intervalo);
			}
		ultima_excitacao = excitacao [3];  // grava a ultima excitacao
		}
	else {
		for (girando = ciclos;girando < 0;girando++) {
			porta.send (excitacao [3]);
			porta.waiting (intervalo);
			porta.send (excitacao [2]);
			porta.waiting (intervalo);
			porta.send (excitacao [1]);
			porta.waiting (intervalo);
			porta.send (excitacao [0]);
			porta.waiting (intervalo);
			}
		ultima_excitacao = excitacao [0];
		};
}
*/



void turn (int angle)

{
	int ciclos;
	static int girando = 0;

	ciclos = (int) (angle / precisao) + girando;

		/* + girando pois girando pode ser != 0... */

	if (ciclos > 0) {
		for (;girando < ciclos;girando++) {
			send (excitacao [girando % 4]);

		/* girando % 4 e' um numero entre 0 e 3... */

			waiting (intervalo);
			}
		ultima_excitacao = excitacao [girando % 4];  /* grava a ultima excitacao */
		girando = girando % 4;		/* atualiza o valor de girando */
		}
	else {
		for (;girando < (-ciclos);girando++) {
			send (excitacao [3 - girando % 4]);
			waiting (intervalo);
			}
		ultima_excitacao = excitacao [3 - girando % 4];
		girando = girando % 4;
		};
}

void wait (int time)

{
	send (ultima_excitacao);		/* envia a ultima excitacao */
						/* usada no motor */
	waiting (time);
}

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char nome[80] = "teste.mot";

void Le_comanda (void)

{
int inteiro;
float real;
FILE *arquivo;
char comando[5],parametro [5];

	if ((arquivo = fopen (nome,"rt")) == NULL) {
		puts ("Arquivo nao existe.");
		exit (0);
                }

	while (fscanf (arquivo,"%s",&comando) > 0) {

		if (strcmp (comando,"S") == 0) {
			fscanf (arquivo,"%s",&parametro);
			inteiro = atoi (parametro);
			set (inteiro);
		}

		if (strcmp (comando,"P") == 0) {
			fscanf (arquivo,"%s",&parametro);
			real = atof (parametro);
			precision (real);
		}

		if (strcmp (comando,"D") == 0) {
			fscanf (arquivo,"%s",&parametro);
			inteiro = atoi (parametro);
			sdelay (inteiro);
		}

		if (strcmp (comando,"T") == 0) {
			fscanf (arquivo,"%s",&parametro);
			inteiro = atoi (parametro);
			turn (inteiro);
		}

		if (strcmp (comando,"W") == 0) {
			fscanf (arquivo,"%s",&parametro);
			inteiro = atoi (parametro);
			wait (inteiro);
		}

		if (strcmp (comando,"SS") == 0)
			sstep ();

		if (strcmp (comando,"DS") == 0)
			dstep ();

		if (strcmp (comando,"O") == 0)
			off ();

		if (strcmp (comando,"AI") == 0)
			sendc (0);

		if (strcmp (comando,"FI") == 0)
			sendc (255);
	}

	fclose (arquivo);

}

int main (int argc,char *argv [])

{
	if (argc > 1)
		strcpy (nome,argv [1]);
	else {
		printf ("Nome do arquivo .MOT : ");
		scanf ("%s",&nome);
		}
	sendc (0);
	Le_comanda ();
	return 0;
}


