// <APPLET CODE=RM.class width=400 height=200></APPLET>

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.*;

//
// Main class for control of the mobile robot
//

public class RM extends Applet {

Button
	b_front = new Button("Front"),
	b_back = new Button("Back"),
	b_left = new Button("Left"),
	b_right = new Button ("Right"),
	b_walk = new Button ("Walk");

Panel 	
	p_joystick = new Panel (),
	p_center = new Panel ();

Checkbox
	c_autonomous = new Checkbox ("Auto");

TextField
	t_distance = new TextField ("1000",5);

Label
	l_milimeters = new Label ("D (mm):"),
	l_message = new Label ("System working.");

public void start() {

	p_joystick.setLayout(new BorderLayout(2,2));

	p_joystick.add (b_front,BorderLayout.NORTH);
	p_joystick.add (b_back,BorderLayout.SOUTH);
	p_joystick.add (b_left,BorderLayout.WEST);
	p_joystick.add (b_right,BorderLayout.EAST);

	b_front.addActionListener (new EventFront ());
	b_back.addActionListener (new EventBack ());
	b_left.addActionListener (new EventLeft ());
	b_right.addActionListener (new EventRight ());

	p_center.add (c_autonomous);
	p_center.add (b_walk);
	p_center.add (l_milimeters);
	p_center.add (t_distance);
	p_center.setLayout (new GridLayout (2,2));

	b_walk.addActionListener (new EventWalk ());
	t_distance.addTextListener (new EventDistance ());

	p_joystick.add (p_center,BorderLayout.CENTER);

	setLayout (new BorderLayout (2,1));
	add (p_joystick,BorderLayout.CENTER);
	add (l_message,BorderLayout.SOUTH);
}

class EventWalk implements ActionListener {

	public void actionPerformed (ActionEvent e) {
		if (c_autonomous.getState())
			try {
				l_message.setText ("Walking autonomously "+t_distance.getText()+"mm.");
				URL CGIWalk = new URL (getCodeBase(),"/cgi-bin/walk?distance="+t_distance.getText());
				c_autonomous.setState(false);
			}
			catch (MalformedURLException me) {
				l_message.setText ("Error connecting server.");
			}
		else
			l_message.setText ("Not in Auto mode.");			
	}
}

class EventDistance implements TextListener {
		public void textValueChanged (TextEvent e) {
			int distance;
			try {
				distance = Integer.parseInt (t_distance.getText());
			}
			catch (NumberFormatException ne) {
				distance = 1000;
				t_distance.setText ("1000");
				l_message.setText ("Invalid character.");
			}
			if (distance > 5000) {
				t_distance.setText ("1000");
				l_message.setText ("Parameter too large.");
			}
		}	
}

class EventFront implements ActionListener {

	public void actionPerformed (ActionEvent e) {
		try {
			l_message.setText ("Going ahead.");
			URL CGIWalk = new URL ("http://robomovel.graco.unb.br/cgi-bin/front");
		}
		catch (MalformedURLException me) {
			l_message.setText ("Error connecting server.");
		}
	}
}

class EventBack implements ActionListener {

	public void actionPerformed (ActionEvent e) {
		try {
			l_message.setText ("Going back.");
			URL CGIWalk = new URL ("http://robomovel.graco.unb.br/cgi-bin/back");
		}
		catch (MalformedURLException me) {
			l_message.setText ("Error connecting server.");
		}
	}
}

class EventLeft implements ActionListener {

	public void actionPerformed (ActionEvent e) {
		try {
			l_message.setText ("Turning left.");
			URL CGIWalk = new URL ("http://robomovel.graco.unb.br/cgi-bin/left");
		}
		catch (MalformedURLException me) {
			l_message.setText ("Error connecting server.");
		}
	}
}

class EventRight implements ActionListener {

	public void actionPerformed (ActionEvent e) {
		try {
			l_message.setText ("Turning right.");
			URL CGIWalk = new URL ("http://robomovel.graco.unb.br/cgi-bin/right");
		}
		catch (MalformedURLException me) {
			l_message.setText ("Error connecting server.");
		}
	}
}


}
