// <APPLET CODE=XRC.class width=400 height=200></APPLET>

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

//
// Main class for control of the XR4000 robot
//

public class XRC extends Applet {

Button
	b_login,
	b_control,
	b_configuration;

Panel
	p_cards = new Panel();

CardLayout
	cl_cards = new CardLayout();

Image
	image;

ImagePanel
	imagePanel;	

int
	language;

String[]
	s_login={"Conecta com o servidor","Login to server"},
	s_control={"Controle","Control"},
	s_configuration={"Configuraes","Configuration"};	

public void init() {

	language = 0;	// portugues (1:ingles)

	setLayout(new BorderLayout(2,2));

	Panel p_menu = new Panel();
	p_menu.setLayout(new GridLayout(3,1,2,2));

	b_login = new Button (s_login[language]);
	b_control = new Button (s_control[language]);
	b_configuration = new Button (s_configuration[language]);

	p_menu.add(b_login);
	p_menu.add(b_control);
	p_menu.add(b_configuration);

	b_login.addActionListener (new L_login ());
	b_control.addActionListener (new L_control ());
	b_configuration.addActionListener (new L_configuration ());
	add("West", p_menu);

        image = getImage(getCodeBase(), "intro.jpg");
        imagePanel = new ImagePanel(image);

	p_cards.setLayout(cl_cards);
	p_cards.add ("intro",
		imagePanel);
	p_cards.add("login",
		new C_login ());
	p_cards.add("control",
      		new Label ("Control the robot"));
	p_cards.add("configuration",
		new C_configuration (language));
	add("Center", p_cards);
}

class L_login implements ActionListener {
	public void actionPerformed (ActionEvent e) {
		cl_cards.show (p_cards,"login");
	}
}

class L_control implements ActionListener {
	public void actionPerformed (ActionEvent e) {
		cl_cards.show (p_cards,"control");
	}
}

class L_configuration implements ActionListener {
	public void actionPerformed (ActionEvent e) {
		cl_cards.show (p_cards,"configuration");
	}
}

}


//
// Class for the robot's configuration
//

class C_configuration extends Panel {

	Choice
		C_language;

	Button
		B_change, B_defaults;
	TextField
		T_speed, T_distance, T_other;
	Scrollbar
		S_speed, S_distance, S_other;

	String[]
		s_speed={"Velocidade","Speed"},
		s_distance={"Distncia de parada","Distance to stop"},
		s_other={"Outro","Other"},
		s_chooselanguage={"Language","Idioma"};

	C_configuration (int language) {

		setLayout (new GridLayout (5,3,2,2));
		add (new Label (s_speed[language]+" (mm/s)"));
		add (T_speed = new TextField ("500"));
		add (S_speed = new Scrollbar (Scrollbar.HORIZONTAL,500,50,100,1050));

		add (new Label (s_distance[language]+" (mm)"));
		add (T_distance = new TextField ("100"));
		add (S_distance = new Scrollbar (Scrollbar.HORIZONTAL,100,50,50,550));

		add (new Label (s_other[language]));
		add (T_other = new TextField ("0"));
		add (S_other = new Scrollbar (Scrollbar.HORIZONTAL));

		add (new Label (s_chooselanguage[language]));
		add (new Label (""));
		add (C_language = new Choice());
		C_language.add ("Portugus");
		C_language.add ("English");

		add (B_change = new Button ("Change"));
		add (new Label (""));
		add (B_defaults = new Button ("Set to defaults"));

		S_speed.setUnitIncrement (50);
		S_speed.setBlockIncrement (100);
		S_distance.setUnitIncrement (50);
		S_distance.setBlockIncrement (100);

		T_speed.addTextListener (new L_T_speed ());
		S_speed.addAdjustmentListener (new L_S_speed ());
	}

	class L_T_speed implements TextListener {
		public void textValueChanged (TextEvent e) {
			int speed;
			try {
				speed = Integer.parseInt (T_speed.getText());
			}
			catch (NumberFormatException ne) {
				speed = 100;
				T_speed.setText ("100");
			}
			if (speed > 1000) {
				speed = 1000;
				T_speed.setText (speed+"");
			}
			S_speed.setValue (speed);
		}
	}



	class L_S_speed implements AdjustmentListener {
		public void adjustmentValueChanged (AdjustmentEvent e) {
			Integer i = new Integer (S_speed.getValue ());
			T_speed.setText (i.toString());
		}
	}

}

//
// Class for login with the robot's server
//

class C_login extends Panel {
	C_login () {
		TextField
			T_login, T_password;

    Button
      B_connect, B_reset;

		setLayout (new GridLayout (3,2,2,2));
		add (new Label ("Login"));
		add (T_login = new TextField (""));

		add (new Label ("Password"));
		add (T_password = new TextField (""));

		T_password.setEchoChar ('*');

    add (B_connect = new Button ("Connect to server"));
    add (B_reset = new Button ("Reset values"));

	}
}

class ImagePanel extends Panel {
    Image image;
    Dimension dimension;

    public ImagePanel(Image image) {
        this.image = image;
    }

    public void paint(Graphics g) {
	dimension = getSize ();
        g.drawImage(image, 0, 0, (int) dimension.getWidth(), (int) dimension.getHeight(), this); //85x62 image
    }
}

