package solid;
import java.util.Hashtable;
/**
* Implementar a classe Serializable eh requisito para ser um
* Enterprise Bean. Um objeto de uma classe que implementa
* esta interface pode ser escrito em disco ou enviado pela rede.
* Nesta aplicao ser apenas verificado a consistncia dos dados.
*/

public class ConeBean implements java.io.Serializable {
/**
* Nomes dos atributos preferencialmente iguais aos usados
* no formulrio
*/
 private String dmai_s;
 private String dmen_s;
 private String altu_s;
 private Hashtable erros;  /* Este atributo serve para o controle de erros no formulrio */


 public ConeBean(){
    dmai_s = "";
    dmen_s = "";
    altu_s = "";
    erros = new Hashtable();
 }

/**
* Mtodos para acessar os atributos.
*/
 public String getDiametroMaior(){ return dmai_s; }
 public String getDiametroMenor(){ return dmen_s; }
 public String getAltura(){ return altu_s; }
 
 public void setDiametroMaior(String valor){ dmai_s = valor; }
 public void setDiametroMenor(String valor){ dmen_s = valor; }
 public void setAltura(String valor){ altu_s = valor; }
 

 public boolean ehValido(){
    if(verificaAltura() && verificaDMaior() && verificaDMenor()){
      return true;
    }

      return false;
 }

 protected boolean verificaAltura(){
   try{
      double temp = Double.parseDouble(altu_s);
      if(temp <= 0){
         erros.put("altu_s", "Digite um nmero positivo para a altura!");
         return false;
      }
    }catch(NumberFormatException e){
         erros.put("altu_s", "Digite um nmero positivo para a altura!");
         return false;
     }
   return true;
 }

 protected boolean verificaDMaior(){
   try{
      double temp = Double.parseDouble(dmai_s);
      if(temp <= 0){
         erros.put("dmai_s", "Digite um nmero positivo para o dimetro maior!");
         return false;
      }
    }catch(NumberFormatException e){
         erros.put("dmai_s", "Digite um nmero positivo para o dimetro maior!");
         return false;
     }
   return true;
 }

 protected boolean verificaDMenor(){
   try{
      double temp = Double.parseDouble(dmen_s);
      if(temp <= 0){
         erros.put("dmen_s", "Digite um nmero positivo para o dimetro menor!");
         return false;
      }
    }catch(NumberFormatException e){
         erros.put("dmen_s", "Digite um nmero positivo para o dimetro menor!");
         return false;
     }
   return true;
 }
/**
*Usado para ver as mensagens de erro armazenados na tabela de Hash
*/
 public String getErros (String s){
    String msg = (String) erros.get(s);
    return (msg == null) ? "" : msg;
 }

/**
* Usado para colocar algum erro na tabela
*/
 public void setErros (String chave, String msg){
   erros.put(chave,msg);
 }

}