package solid;
import java.util.Hashtable;
/**
* Implementar a classe Serializable eh requisito para ser um
* Enterprise Bean. Um objeto de uma classe que implementa
* esta interface pode ser escrito em disco ou enviado pela rede.
* Nesta aplicao ser apenas verificado a consistncia dos dados.
*/

public class EixoBean{
/**
* Nomes dos atributos preferencialmente iguais aos usados
* no formulrio
*/
  private String[] diam_e;
  private String[] diam_d;
  private String[] comp;
  private String[] blend_e;
  private String[] vblend_e;
  private String[] blend_d;
  private String[] vblend_d;
  private String qtd_cilindros;
  private String seccao;
  private String codigoFuro;
  private String dfuro;
  private String profuro;
  private Hashtable erros; /* Este atributo serve para o controle de erros no formulrio */

  public EixoBean(){
     diam_e = new String[20];
     diam_d = new String[20];
     comp = new String[20];
     blend_e = new String[20];
     vblend_e = new String[20];
     blend_d = new String[20];
     vblend_d = new String[20];
     qtd_cilindros = "";
     seccao = "";
     codigoFuro = "";
     dfuro = "";
     profuro = "";
     erros = new Hashtable();
  }

/**
* Mtodos para acessar os atributos.
*/
 public String getDiametroEsquerdo(int p){ return diam_e[p]; }
 public String getDiametroDireito(int p){ return diam_d[p]; }
 public String getComprimento(int p){ return comp[p]; }
 public String getTipoBlendEsquerdo(int p){ return blend_e[p]; }
 public String getValorBlendEsquerdo(int p){ return vblend_e[p]; }
 public String getTipoBlendDireito(int p){ return blend_d[p]; }
 public String getValorBlendDireito(int p){ return vblend_d[p]; }

 public String getDiametroEsquerdo(){
   String str = "";
   for(int i = 0; i < Integer.parseInt(getQuantidade()); i++){
     str += (diam_e[i] + "-");
   }
   return str;
 }

 public String getDiametroDireito(){
   String str = "";
   for(int i = 0; i < Integer.parseInt(getQuantidade()); i++){
     str += (diam_d[i] + "-");
   }
   return str;
 }

 public String getComprimento(){
   String str = "";
   for(int i = 0; i < Integer.parseInt(getQuantidade()); i++){
     str += (comp[i] + "-");
   }
   return str;
 }

 public String getTipoBlendEsquerdo(){
   String str = "";
   for(int i = 0; i < Integer.parseInt(getQuantidade()); i++){
     str += (blend_e[i] + "-");
   }
   return str;
 }

 public String getValorBlendEsquerdo(){
   String str = "";
   for(int i = 0; i < Integer.parseInt(getQuantidade()); i++){
     str += (vblend_e[i] + "-");
   }
   return str;
 }

 public String getTipoBlendDireito(){
   String str = "";
   for(int i = 0; i < Integer.parseInt(getQuantidade()); i++){
     str += (blend_d[i] + "-");
   }
   return str;
 }

 public String getValorBlendDireito(){
   String str = "";
   for(int i = 0; i < Integer.parseInt(getQuantidade()); i++){
     str += (vblend_d[i] + "-");
   }
   return str;
 }

 public String getQuantidade(){ return qtd_cilindros; }
 public String getSeccao(){ return seccao; }
 public String getCodigoFuro(){ return codigoFuro; }
 public String getDiametroFuro(){ return dfuro; }
 public String getProfundidadeFuro(){ return profuro; }

 public void setDiametroEsquerdo(String valor, int p){ diam_e[p] = valor; }
 public void setDiametroDireito(String valor, int p){ diam_d[p] = valor; }
 public void setComprimento(String valor, int p){ comp[p] = valor; }

 public void setTipoBlendEsquerdo(String valor, int p){ blend_e[p] = valor; }
 public void setValorBlendEsquerdo(String valor, int p){ vblend_e[p] = valor; }
 public void setTipoBlendDireito(String valor, int p){ blend_d[p] = valor; }
 public void setValorBlendDireito(String valor, int p){ vblend_d[p] = valor; }

 public void setQuantidade(String valor){ qtd_cilindros = valor; }
 public void setSeccao(String valor){ seccao = valor; }
 public void setCodigoFuro(String valor){ codigoFuro = valor; }
 public void setDiametroFuro(String valor){ dfuro = valor; }
 public void setProfundidadeFuro(String valor){ profuro = valor; }

 public boolean ehValido(){
   if(verificaDiametroEsquerdo() && verificaDiametroDireito() && verificaComprimento() &&
      verificaFuro() && verificaBlend()){
      return true;
   }

      return false;
 }

 public boolean verificaQuantidade(){
   try{
      double q = Double.parseDouble(qtd_cilindros);
      if(q <= 0){
         erros.put("qtd_cilindros", "Digite um nmero positivo para a quantidade de cilindros!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("qtd_cilindros", "Digite um nmero positivo para a quantidade de cilindros!");
         return false;
    }
   return true;
 }

 protected boolean verificaDiametroEsquerdo(){
   for(int i = 0; i < Integer.parseInt(qtd_cilindros); i++){
     try{
        double temp = Double.parseDouble(diam_e[i]);
        if(temp <= 0){
          erros.put("diam_e"+i, "Digite um nmero positivo para o dimetro esquerdo!");
          return false;
        }

     }catch(NumberFormatException e){
         erros.put("diam_e"+i, "Digite um nmero positivo para o dimetro esquerdo!");
         return false;
      }
   }
   return true;
 }

 protected boolean verificaDiametroDireito(){
   for(int i = 0; i < Integer.parseInt(qtd_cilindros); i++){
     try{
        double temp = Double.parseDouble(diam_d[i]);
        if(temp <= 0){
          erros.put("diam_d"+i, "Digite um nmero positivo para o dimetro direito!");
          return false;
        }

     }catch(NumberFormatException e){
         erros.put("diam_d"+i, "Digite um nmero positivo para o dimetro direito!");
         return false;
      }
   }
   return true;
 }

 protected boolean verificaComprimento(){
   for(int i = 0; i < Integer.parseInt(qtd_cilindros); i++){
     try{
        double temp = Double.parseDouble(comp[i]);
        if(temp <= 0){
          erros.put("comp"+i, "Digite um nmero positivo para o comprimento!");
          return false;
        }

     }catch(NumberFormatException e){
         erros.put("comp"+i, "Digite um nmero positivo para o comprimento!");
         return false;
      }
   }
   return true;
 }

 protected boolean verificaFuro(){
   if(verificaProfundidadeFuro() && verificaDiametroFuro()){
     return true;
   }

   return false;
 }

 protected boolean verificaDiametroFuro(){
   int q = Integer.parseInt(qtd_cilindros);
   if(Integer.parseInt(codigoFuro) > 1){
     try{
          double temp = Double.parseDouble(dfuro);
          if(temp <= 0){
            erros.put("dfuro", "Digite um nmero positivo para o dimetro do furo!");
            return false;
          }else{
             //Furo da direita
             if(codigoFuro.equals("2") && temp >= Double.parseDouble(diam_d[q - 1])){
               erros.put("dfuro", "Digite um nmero para o dimetro do furo que seja MENOR que o dimetro direito do eixo!");
               return false;
             }
             //Furo da esquerda
             if(codigoFuro.equals("3") && temp >= Double.parseDouble(diam_e[0])){
               erros.put("dfuro", "Digite um nmero para o dimetro do furo que seja MENOR que o dimetro esquerdo do eixo!");
               return false;
             }
             //Furo passante
             if(codigoFuro.equals("4")){
               for(int i = 0; i < q; i++){
                 if(temp >= Double.parseDouble(diam_e[i]) || temp >= Double.parseDouble(diam_d[i])){
                   erros.put("dfuro", "Digite um nmero para o dimetro do furo que seja MENOR que o dimetro mnimo do eixo!");
                   return false;
                 }
               }
             }
           }
     }catch(NumberFormatException e){
           erros.put("dfuro", "Digite um nmero positivo para o dimetro do furo!");
           return false;
      }
   }
    return true;
 }

 protected boolean verificaProfundidadeFuro(){
   int q = Integer.parseInt(qtd_cilindros);
   if(Integer.parseInt(codigoFuro) > 1 && Integer.parseInt(codigoFuro) < 4){
     try{
          double temp = Double.parseDouble(profuro);
          if(temp <= 0){
            erros.put("profuro", "Digite um nmero positivo para a profundidade do furo!");
            return false;
          }else{
             //Furo da direita
             if(codigoFuro.equals("2") && temp >= Double.parseDouble(comp[q - 1])){
               erros.put("profuro", "Digite um nmero para a profundidade do furo que seja MENOR que o comprimento do cilindro/cone direito!");
               return false;
             }
             //Furo da esquerda
             if(codigoFuro.equals("3") && temp >= Double.parseDouble(comp[0])){
               erros.put("profuro", "Digite um nmero para a profundidade do furo que seja MENOR que o comprimento do cilindro/cone esquerdo!");
               return false;
             }
          }
     }catch(NumberFormatException e){
           erros.put("profuro", "Digite um nmero positivo para a profundidade do furo!");
           return false;
      }
   }
    return true;
 }

 protected boolean verificaBlend(){
   if(verificaBlendEsquerdo() && verificaBlendDireito()){
     return true;
   }

   return false;
 }

 protected boolean verificaBlendEsquerdo(){
   int q = Integer.parseInt(qtd_cilindros);
   for(int i = 0; i < q; i++){
    try{
      if(!blend_e[i].equals("0")){ //Se for chanfro ou raio de concordncia...
        double temp = Double.parseDouble(vblend_e[i]);
        if(temp < 0){
          if(blend_e[i].equals("1")){ //Chanfro
            erros.put("vblend_e"+i, "Digite um nmero positivo para o chanfro esquerdo!");
          }else{ //Raio de concordncia
            erros.put("vblend_e"+i, "Digite um nmero positivo para o raio de concordncia esquerdo!");
           }
          return false;
        }else{
           double blend = Double.parseDouble(vblend_e[i]);
           double de = Double.parseDouble(diam_e[i]);
           if(de/2 >= blend){
             if(i > 0){
               double dd = Double.parseDouble(diam_d[i-1]);
               if(!(Math.abs(dd - de)/2 >= blend)){
                 if(blend_e[i].equals("1")){ //Chanfro
                   erros.put("vblend_e"+i, "Digite um nmero MENOR para o chanfro esquerdo!");
                 }else{ //Raio de concordncia
                    erros.put("vblend_e"+i, "Digite um nmero MENOR para o raio de concordncia esquerdo!");
                  }
                  return false;
               }
             }

           }else{
              if(blend_e[i].equals("1")){ //Chanfro
                erros.put("vblend_e"+i, "Digite um nmero MENOR para o chanfro esquerdo!");
              }else{ //Raio de concordncia
                 erros.put("vblend_e"+i, "Digite um nmero MENOR para o raio de concordncia esquerdo!");
               }
              return false;
            }
         }
      }
     }catch(NumberFormatException e){
         if(blend_e[i].equals("1")){ //Chanfro
            erros.put("vblend_e"+i, "Digite um nmero positivo para o chanfro esquerdo!");
          }else{ //Raio de concordncia
            erros.put("vblend_e"+i, "Digite um nmero positivo para o raio de concordncia esquerdo!");
           }
          return false;
      }
   }
   return true;
 }

 protected boolean verificaBlendDireito(){
   int q = Integer.parseInt(qtd_cilindros);
   for(int i = 0; i < q; i++){
    try{
      if(!blend_d[i].equals("0")){ //Se for chanfro ou raio de concordncia...
        double temp = Double.parseDouble(vblend_e[i]);
        if(temp < 0){
          if(blend_d[i].equals("1")){ //Chanfro
            erros.put("vblend_d"+i, "Digite um nmero positivo para o chanfro direito!");
          }else{ //Raio de concordncia
            erros.put("vblend_d"+i, "Digite um nmero positivo para o raio de concordncia direito!");
           }
          return false;
        }else{
           double blend = Double.parseDouble(vblend_d[i]);
           double dd = Double.parseDouble(diam_d[i]);
           if(dd/2 >= blend){
             if(i < q-1){
               double de = Double.parseDouble(diam_e[i+1]);
               if(!(Math.abs(dd - de)/2 >= blend)){
                 if(blend_d[i].equals("1")){ //Chanfro
                   erros.put("vblend_d"+i, "Digite um nmero MENOR para o chanfro direito!");
                 }else{ //Raio de concordncia
                    erros.put("vblend_d"+i, "Digite um nmero MENOR para o raio de concordncia direito!");
                  }
                  return false;
               }
             }

           }else{
              if(blend_d[i].equals("1")){ //Chanfro
                erros.put("vblend_d"+i, "Digite um nmero MENOR para o chanfro direito!");
              }else{ //Raio de concordncia
                 erros.put("vblend_d"+i, "Digite um nmero MENOR para o raio de concordncia direito!");
               }
              return false;
            }
         }
      }
     }catch(NumberFormatException e){
         if(blend_d[i].equals("1")){ //Chanfro
            erros.put("vblend_d"+i, "Digite um nmero positivo para o chanfro direito!");
          }else{ //Raio de concordncia
            erros.put("vblend_d"+i, "Digite um nmero positivo para o raio de concordncia direito!");
           }
          return false;
      }
   }
   return true;
 }

/**
*Usado para ver as mensagens de erro armazenados na tabela de Hash
*/
 public String getErros (String s){
    String msg = (String) erros.get(s);
    return (msg == null) ? "" : msg;
 }

/**
* Usado para colocar algum erro na tabela
*/
 public void setErros (String chave, String msg){
    erros.put(chave,msg);
 }
/*
public static void main(String[] args){

  Teste eixo = new Teste();
  for(int i = 0; i < 20; i++){
    eixo.setDiametroEsquerdo("valor"+i, i);
    eixo.setDiametroDireito("valor"+i, i);
    eixo.setComprimento("valor"+i, i);
    eixo.setTipoBlendEsquerdo("valor"+i, i);
    eixo.setValorBlendEsquerdo("valor"+i, i);
    eixo.setTipoBlendDireito("valor"+i, i);
    eixo.setValorBlendDireito("valor"+i, i);
  }
    eixo.setQuantidade("10");
    System.out.println("diametro esquerdo: "+ eixo.getDiametroEsquerdo());
    System.out.println("diametro direito: "+ eixo.getDiametroDireito());
    System.out.println("comprimento: "+ eixo.getComprimento());
    System.out.println("tipo blend esquerdo: "+ eixo.getTipoBlendEsquerdo());
    System.out.println("tipo blend direito: "+ eixo.getTipoBlendDireito());
    System.out.println("valor blend esquerdo: "+ eixo.getValorBlendEsquerdo());
    System.out.println("valor blend direito: "+ eixo.getValorBlendDireito());
} */


}