package solid;
import java.util.Hashtable;
/**
* Implementar a classe Serializable eh requisito para ser um
* Enterprise Bean. Um objeto de uma classe que implementa
* esta interface pode ser escrito em disco ou enviado pela rede.
* Nesta aplicao ser apenas verificado a consistncia dos dados.
*/

public class EsferaBean implements java.io.Serializable {
/**
* Nomes dos atributos preferencialmente iguais aos usados
* no formulrio
*/
 private String diam_s;
 private Hashtable erros; /* Este atributo serve para o controle de erros no formulrio */


 public EsferaBean() {
    diam_s = "";
    erros = new Hashtable();
 }

/**
* Mtodos para acessar os atributos.
*/
 public String getDiametro(){ return diam_s; }
 
 public void setDiametro(String valor){ diam_s = valor; }
 

 public boolean ehValido(){
    if(verificaDiametro()){
      return true;
    }

    return false;
 }

 protected boolean verificaDiametro(){
   try{
      double diam = Double.parseDouble(diam_s);
      if(diam < 0){
         erros.put("diam_s", "Digite um nmero positivo para o dimetro!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("diam_s", "Digite um nmero positivo para o dimetro!");
         return false;
    }
   return true;
 }
/**
*Usado para ver as mensagens de erro armazenados na tabela de Hash
*/
public String getErros (String s)
{
String msg = (String) erros.get(s);
return (msg == null) ? "" : msg;
}

/**
* Usado para colocar algum erro na tabela
*/
public void setErros (String chave, String msg)
{
erros.put(chave,msg);
}
}