package solid;
import java.util.Hashtable;
/**
* Implementar a classe Serializable eh requisito para ser um
* Enterprise Bean. Um objeto de uma classe que implementa
* esta interface pode ser escrito em disco ou enviado pela rede.
* Nesta aplicao ser apenas verificado a consistncia dos dados.
*/

public class PiramedeEBean implements java.io.Serializable {
/**
* Nomes dos atributos preferencialmente iguais aos usados
* no formulrio
*/
 private String nlados_s;
 private String rmai_s;
 private String rmen_s;
 private String rtop_s;
 private String altu_s;
 private String tipo;
 private String nome;
 private Hashtable erros; /* Este atributo serve para o controle de erros no formulrio */


 public PiramedeEBean() {
    nlados_s = "";
    rmai_s = "";
    rmen_s = "";
    rtop_s = "";
    altu_s = "";
    tipo = "";
    nome = "";
    erros = new Hashtable();
 }

/**
* Mtodos para acessar os atributos.
*/
 public String getNumeroLados(){ return nlados_s; }
 public String getRaioMaior(){ return rmai_s; }
 public String getRaioMenor(){ return rmen_s; }
 public String getRaioTopo(){ return rtop_s; }
 public String getAltura(){ return altu_s; }
 public String getNome(){ return nome; }
 public String getTipo(){ return tipo; }

 public void setNumeroLados(String valor){ nlados_s = valor; }
 public void setRaioMaior(String valor){ rmai_s = valor; }
 public void setRaioMenor(String valor){ rmen_s = valor; }
 public void setRaioTopo(String valor){ rtop_s = valor; }
 public void setAltura(String valor){ altu_s = valor; }
 public void setNome(String valor){ nome = valor; }
 public void setTipo(String valor){ tipo = valor; }


public boolean ehValido(){
    if(verificaNLados() && verificaRMaior() && verificaRMenor() && verificaAltura()){
      return true;
    }

      return false;
 }

 protected boolean verificaNLados(){
   try{
      double nlados = Double.parseDouble(nlados_s);
      if(nlados < 0){
         erros.put("nlados_s", "Digite um nmero positivo para o n de lados!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("nlados_s", "Digite um nmero positivo para o n de lados!");
         return false;
    }
   return true;
 }

 protected boolean verificaRMaior(){
   try{
      double rmai = Double.parseDouble(rmai_s);
      if(rmai < 0){
         erros.put("rmai_s", "Digite um nmero positivo para o raio maior!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("rmai_s", "Digite um nmero positivo para o raio maior!");
         return false;
    }
   return true;
 }

 protected boolean verificaRMenor(){
   try{
      double rmen = Double.parseDouble(rmen_s);
      if(rmen < 0){
         erros.put("rmen_s", "Digite um nmero positivo para o raio menor!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("rmen_s", "Digite um nmero positivo para o raio menor!");
         return false;
    }
   return true;
 }

 protected boolean verificaRTopo(){
   try{
      double rtop = Double.parseDouble(rtop_s);
      if(rtop < 0){
         erros.put("rtop_s", "Digite um nmero positivo para o raio do topo!");
         return false;
      }
   }catch(NumberFormatException e){
         erros.put("rtop_s", "Digite um nmero positivo para o raio do topo!");
         return false;
    }
   return true;
 }

 protected boolean verificaAltura(){
   try{
      double altu = Double.parseDouble(altu_s);
      if(altu < 0){
         erros.put("altu_s", "Digite um nmero positivo para o comprimento!");
         return false;
      }
    }catch(NumberFormatException e){
         erros.put("altu_s", "Digite um nmero positivo para o comprimento!");
         return false;
     }
   return true;
 }

/**
*Usado para ver as mensagens de erro armazenados na tabela de Hash
*/
 public String getErros (String s){
    String msg = (String) erros.get(s);
    return (msg == null) ? "" : msg;
 }

/**
* Usado para colocar algum erro na tabela
*/
 public void setErros (String chave, String msg){
    erros.put(chave,msg);
 }
}