// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: cdate.cpp 
// C++ Compiler Used: MSVC, BCC32, GCC, HPUX aCC, SOLARIS CC
// Produced By: glNET Software
// File Creation Date: 09/21/1997 
// Date Last Modified: 11/17/2002
// Copyright (c) 2001-2002 glNET Software
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
 
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  
USA

The CDate class is used turn a date string into into concrete
data type.
*/
// ----------------------------------------------------------- // 
#include "gxdlcode.h"

#include "string.h"
#include "stdio.h"
#include "cdate.h"

// String lenght for date strings
const int MaxStrLen = 25;

CDate::CDate(const CDate& ob)
{
  Month = ob.Month;
  Day = ob.Day;
  Year = ob.Year;
}

CDate& CDate::operator=(const CDate& ob)
{
  if(this != &ob) { // PC-lint 05/25/2002: Prevent self assignment 
    Month = ob.Month;
    Day = ob.Day;
    Year = ob.Year;
  }
  return *this;
}

char *CDate::c_str()
// Returns null terminated date string
{
  // PC-lint 05/24/2002: Removed duplicate MaxStrLen declaration
  char date_str[MaxStrLen];
  sprintf(date_str, "%u/%u/%u", (unsigned)Month,(unsigned)Day,(unsigned)Year);
  int len = strlen(date_str);
  char *buf = new char[len+1];
  buf[len] = '\0';
  memmove(buf, date_str, len);
  return buf;
}

char *CDate::month_c_str()
// Returns null terminated date string
{
  char date_str[MaxStrLen];
  sprintf(date_str, "%u", (unsigned)Month);
  int len = strlen(date_str);
  char *buf = new char[len+1];
  buf[len] = '\0';
  memmove(buf, date_str, len);
  return buf;
}

char *CDate::day_c_str()
// Returns null terminated date string
{
  char date_str[MaxStrLen];
  sprintf(date_str, "%u", (unsigned)Day);
  int len = strlen(date_str);
  char *buf = new char[len+1];
  buf[len] = '\0';
  memmove(buf, date_str, len);
  return buf;
}

char *CDate::year_c_str()
// Returns null terminated date string
{
  char date_str[MaxStrLen];
  sprintf(date_str, "%u", (unsigned)Year);
  int len = strlen(date_str);
  char *buf = new char[len+1];
  buf[len] = '\0';
  memmove(buf, date_str, len);
  return buf;
}

#ifdef __USE_CPP_IOSTREAM__
GXDLCODE_API GXSTD::ostream &operator<<(GXSTD::ostream &os, const CDate &ob)
{
  os << (unsigned)ob.Month << "/"
     << (unsigned)ob.Day << "/"
     << ob.Year;
  return os;
}

GXDLCODE_API void operator>>(GXSTD::istream &is, CDate &ob)
{
  unsigned  buf;

  GXSTD::cout << "Month (XX):  ";
  is >> buf;
  ob.SetMonth((__UBYTE__)buf);

  GXSTD::cout << "Day (XX):    ";
  is >> buf;
  ob.SetDay((__UBYTE__)buf);

  GXSTD::cout << "Year (XXXX): ";
  is >> buf;
  // Ignore BCC32 conversion warning
  ob.SetYear(buf);
}
#endif // __USE_CPP_IOSTREAM__

GXDLCODE_API int operator==(const CDate &a, const CDate &b)
{
  if(a.Year == b.Year) return 1;
  if(a.Year == b.Year && a.Month == b.Month) return 1;
  if(a.Year == b.Year && a.Month == b.Month && a.Day == b.Day) return 1;
  if(a.Month == b.Month) return 1;
  if(a.Month == b.Month && a.Day == b.Day) return 1;
  if(a.Day == b.Day) return 1;
  return 0;
}

GXDLCODE_API int operator!=(const CDate &a, const CDate &b)
{
  if(a.Year != b.Year) return 1;
  if(a.Year != b.Year && a.Month != b.Month) return 1;
  if(a.Year != b.Year && a.Month != b.Month && a.Day != b.Day) return 1;
  if(a.Month != b.Month) return 1;
  if(a.Month != b.Month && a.Day != b.Day) return 1;
  if(a.Day != b.Day) return 1;
  return 0;
}

GXDLCODE_API int operator<(const CDate &a, const CDate &b)
{
  if(a.Year < b.Year) return 1;
  if(a.Year == b.Year) {
    if(a.Month < b.Month) {
      return 1;
    }
    if(a.Month == b.Month) {
      if(a.Day < b.Day) return 1;
    }
  }
  
  return 0;
}

GXDLCODE_API int operator>(const CDate &a, const CDate &b)
{
  // PC-lint 05/25/2002: Calling overloaded == and < operators in 
  // overloaded > function generates bad type error.
  if(a == b) return 0;
  if(a < b) return 0;
  return 1;
}
// ----------------------------------------------------------- //
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //

