#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <termios.h>
#include <errno.h>
#include <time.h>
#include <asm/io.h>

#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define BAUDRATE B4800
#define MODEMDEVICE "/dev/ttyS1"
#define TRUE 1
#define FALSE 0

volatile int STOP=FALSE;

main()
{

int fd, NOB, i, prog, res;
struct termios oldtio, newtio;
char st[7], buf[255];

time_t TimeSec;

fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY ); /* | O_NDELAY); */
if (fd<0)
   {
    perror(MODEMDEVICE);
    exit(-1);
   }   
/* BAUDRATE | CRTSCTS | CS7 | PARENB | CLOCAL | CREAD; */
tcgetattr(fd,&oldtio); /* save current serial port settings */
bzero(&newtio, sizeof(newtio)); /* clear struct for new port settings */
newtio.c_cflag = BAUDRATE | CS7 | CLOCAL | CREAD; /* | PARENB */
newtio.c_iflag = IGNPAR | ICRNL;
newtio.c_oflag = 0;
newtio.c_lflag =  ICANON; /* 0; */

/* Para entrada de dados Non Canonical comentar as duas linhas seguintes */

newtio.c_cc[VMIN]=7;   /* blocking read until 5 chars received */
newtio.c_cc[VTIME]=0;   /* inter-character timer unused */


tcflush(fd,TCIFLUSH);
tcsetattr(fd,TCSANOW,&newtio);


/* FASE 2 TRANSMISSAO */

write(fd,"@04S!",5);

ioperm (0x02f8,1,1);
 
st[1]=inb(0x02f8);
st[2]=inb(0x02f8);
st[3]=inb(0x02f8);
st[3]=inb(0x02f8);
st[4]=inb(0x02f8);
st[5]=inb(0x02f8);
st[6]=inb(0x02f8);
st[7]=inb(0x02f8);

 	printf("Status:%s\n",st);


while (STOP==FALSE) {     /* loop until we have a terminating condition */
/* read blocks program execution until a line terminating character is
     input, even if more than 255 chars are input. If the number
     of characters read is smaller than the number of chars available,
     subsequent reads will return the remaining chars. res will be set
     to the actual number of characters actually read */
res = read(fd,buf,255);
buf[res]=0;             /* set end of string, so we can printf */
printf(":%s:%d\n", buf, res);
if (buf[0]=='z') STOP=TRUE; 

/* restore the old port settings */
tcsetattr(fd,TCSANOW,&oldtio);

close (fd);

}
