#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <time.h>

/*

class Interface
versao para Linux / Unix

A classe Interface prove uma base de comunicacao para a classe Motor 
controlar um motor de passo ligado a porta paralela

Esta implementacao utiliza o comando "open", e pode ser usada para acesso
a porta paralela sem acesso de ROOT.

*/


class Interface {
	private:
	 	int	porta;

	public:
			Interface ();		// construtor
			~Interface ();		// destrutor
		void 	send (int n);
		void 	waiting (int t);
};

	Interface :: Interface ()

// Construtor abre o acesso a porta paralela do computador

{
	porta = open ("/dev/lp1",O_WRONLY,0);
	if (porta < 0) {
		printf ("Porta nao disponivel!\n");
		exit (0);
	}
}

	Interface :: ~Interface ()

// Destrutor que fecha o acesso a porta paralela do computador

{
	close (porta);
}

void Interface :: send (int n)

// Envia o inteiro n para a porta paralela

{
char cbuf = (char) n;
int ibuf;

	if (write (porta,&cbuf,1) != 1) {
		printf ("Erro na porta.");
		exit (0);
	}
	
//	if (ioctl (porta,LPGETSTATUS, (char *) &ibuf) < 0) {
//		printf ("erro ioctl em /dev/lp0: %s\n",_sys_errlist [errno]);
//		exit (0);
//	}
}

void Interface :: waiting (int t)

// Faz uma interrupcao de t milisegundos no sistema

{
	usleep (t*1000);
}
