// Classe que define o objeto motor
//
// Utiliza a classe Interface (interfac.cpp)
//
// espera-se que nao seja mudada para a versao Linux.

int motor1_s [4] = {0x01,0x02,0x04,0x08},
    motor2_s [4] = {0x10,0x20,0x40,0x80},
    motor1_d [4] = {0x09,0x03,0x06,0x0C},
    motor2_d [4] = {0x90,0x30,0x60,0xC0};

class Motor {
	private:

		int	numero,intervalo,
                        tipo_excitacao,
		 	excitacao [4],
			ultima_excitacao;
		float	precisao;

	public:

		void	set (int n);		// define o motor usado
		void 	precision (float p);	// define a precisao do motor
		void 	delay (int tempo);	// define o intervalo entre passos
		void 	turn (int angle);	// gira angulo
		void	wait (int time);	// espera tempo excitado
		void	sstep (void);		// define excitacao simples
		void	dstep (void);		// define excitacao dupla
		void    off (void);		// desliga a excitacao do motor
};

void Motor :: set (int n)

{	numero = n;
	if (tipo_excitacao)
	   dstep ();
	else
	   sstep ();
}

void Motor :: sstep (void)

{
	if (numero == 0) {
		excitacao [0] = motor1_s [0] | motor2_s [0];
		excitacao [1] = motor1_s [1] | motor2_s [1];
		excitacao [2] = motor1_s [2] | motor2_s [2];
		excitacao [3] = motor1_s [3] | motor2_s [3]; }
	if (numero == 1) {
		excitacao [0] = motor1_s [0];
		excitacao [1] = motor1_s [1];
		excitacao [2] = motor1_s [2];
		excitacao [3] = motor1_s [3]; }
	if (numero == 2) {
		excitacao [0] = motor2_s [0];
		excitacao [1] = motor2_s [1];
		excitacao [2] = motor2_s [2];
		excitacao [3] = motor2_s [3]; }
	tipo_excitacao = 0;
}

void Motor :: dstep (void)

{
	if (numero == 0) {
		excitacao [0] = motor1_d [0] | motor2_d [0];
		excitacao [1] = motor1_d [1] | motor2_d [1];
		excitacao [2] = motor1_d [2] | motor2_d [2];
		excitacao [3] = motor1_d [3] | motor2_d [3];  }
	if (numero == 1) {
		excitacao [0] = motor1_d [0];
		excitacao [1] = motor1_d [1];
		excitacao [2] = motor1_d [2];
		excitacao [3] = motor1_d [3]; }
	if (numero == 2) {
		excitacao [0] = motor2_d [0];
		excitacao [1] = motor2_d [1];
		excitacao [2] = motor2_d [2];
		excitacao [3] = motor2_d [3]; }
	tipo_excitacao = 1;
}


void Motor :: off (void)

{
	class Interface porta;

	ultima_excitacao = 0x00;
	porta.send (0x00);
}

void Motor :: precision (float p)

{
	precisao = p;
}

void Motor :: delay (int tempo)

{
	intervalo = tempo;
}

/*

Esta rotina possui passo de 7.2 graus, pois efetua 4 passos de uma vez...

void Motor :: turn (int angle)

{
	int ciclos,girando;
	class Interface porta;

	ciclos = (int) (angle / precisao);
	if (ciclos > 0) {
		for (girando = 0;girando < ciclos;girando++) {
			porta.send (excitacao [0]);
			porta.waiting (intervalo);
			porta.send (excitacao [1]);
			porta.waiting (intervalo);
			porta.send (excitacao [2]);
			porta.waiting (intervalo);
			porta.send (excitacao [3]);
			porta.waiting (intervalo);
			}
		ultima_excitacao = excitacao [3];  // grava a ultima excitacao
		}
	else {
		for (girando = ciclos;girando < 0;girando++) {
			porta.send (excitacao [3]);
			porta.waiting (intervalo);
			porta.send (excitacao [2]);
			porta.waiting (intervalo);
			porta.send (excitacao [1]);
			porta.waiting (intervalo);
			porta.send (excitacao [0]);
			porta.waiting (intervalo);
			}
		ultima_excitacao = excitacao [0];
		};
}
*/

// nova versao da rotina Motor :: turn para funcionar com passo de 1.8 graus.
// 
// Esta funo precisa verificar o estado de Interface.Get () para saber
// se h algum sensor sendo ativado...


void Motor :: turn (int angle)

{
	int ciclos;
	static int girando = 0;
	class Interface porta;

	ciclos = (int) (angle / precisao) + girando;

		// + girando pois girando pode ser != 0...

	if (ciclos > 0) {
		for (;girando < ciclos;girando++) {
			porta.send (excitacao [girando % 4]);

		// girando % 4 e' um numero entre 0 e 3...

			porta.waiting (intervalo);
			}
		ultima_excitacao = excitacao [girando % 4];  // grava a ultima excitacao
		girando = girando % 4;		// atualiza o valor de girando
		}
	else {
		for (;girando < (-ciclos);girando++) {
			porta.send (excitacao [3 - girando % 4]);
			porta.waiting (intervalo);
			}
		ultima_excitacao = excitacao [3 - girando % 4];
		girando = girando % 4;
		};
}

void Motor :: wait (int time)

{
	class Interface porta;

	porta.send (ultima_excitacao);		// envia a ultima excitacao
						// usada no motor
	porta.waiting (time);
}
